SystemOrganization addCategory: #'Daliot-Juggle'!
SystemOrganization addCategory: #'Daliot-SBE-Morphic'!
SystemOrganization addCategory: #'Daliot-Maxclub'!
SystemOrganization addCategory: #'Daliot-WoodCut'!
SystemOrganization addCategory: #'Daliot-FileSync'!
SystemOrganization addCategory: #'Daliot-MagicSquare'!
SystemOrganization addCategory: #'Daliot-SICP'!
SystemOrganization addCategory: #'Daliot-common'!
SystemOrganization addCategory: #'Daliot-VendingMachine'!

Morph subclass: #CrossMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SBE-Morphic'!

!CrossMorph methodsFor: 'geometry testing' stamp: 'hjo 3/14/2008 19:46'!
containsPoint: aPoint

	| aBounds1 aBounds2 crossHeight crossWidth |
	crossHeight := (self height / 3) asFloat.
	crossWidth := (self width / 3) asFloat.
	aBounds1 := self bounds top: self top + crossHeight.
	aBounds1 := aBounds1 bottom: self bottom - crossHeight.
	aBounds2 := self bounds left: self left + crossWidth.
	aBounds2 := aBounds2 right: self right - crossWidth.
	^ (aBounds1 containsPoint: aPoint) | (aBounds2 containsPoint: aPoint)! !

!CrossMorph methodsFor: 'drawing' stamp: 'hjo 3/14/2008 19:36'!
drawOn: aCanvas

	| aBounds crossHeight crossWidth |
	crossHeight := (self height / 3) asFloat.
	crossWidth := (self width / 3) asFloat.
	aBounds := self bounds top: self top + crossHeight.
	aBounds := aBounds bottom: self bottom - crossHeight.
	aCanvas fillRectangle: aBounds color: self color.
	aBounds := self bounds left: self left + crossWidth.
	aBounds := aBounds right: self right - crossWidth.
	aCanvas fillRectangle: aBounds color: self color! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 21:11'!
handleKeystroke: anEvent

	| keyValue |
	keyValue := anEvent keyValue.
	keyValue = 30 ifTrue: [self position: self position - (0@1)].
	keyValue = 31 ifTrue: [self position: self position + (0@1)].
	keyValue = 29 ifTrue: [self position: self position + (1@0)].
	keyValue = 28 ifTrue: [self position: self position - (1@0)]! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 20:58'!
handlesMouseDown: anEvent

	^true! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 21:05'!
handlesMouseOver: anEvent

	"need this to get keyboard events"
	^true! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 21:00'!
mouseDown: anEvent

	anEvent redButtonPressed
		ifTrue: [self color: Color red].
	anEvent yellowButtonPressed
		ifTrue: [self color: Color yellow].
	self changed! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 21:06'!
mouseEnter: anEvent

	"need this to get keyboard events"
	anEvent hand newKeyboardFocus: self! !

!CrossMorph methodsFor: 'event handling' stamp: 'hjo 3/14/2008 21:07'!
mouseLeave: anEvent

	anEvent hand newKeyboardFocus: nil! !

!CrossMorph methodsFor: 'stepping and presenter' stamp: 'hjo 3/15/2008 18:16'!
step

	(self color diff: Color black) < 0.1
		ifTrue: []
		ifFalse: [self color: self color darker]! !

!CrossMorph methodsFor: 'testing' stamp: 'hjo 3/14/2008 21:14'!
stepTime

	^100! !

Morph subclass: #DroppedMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SBE-Morphic'!

!DroppedMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/14/2008 21:45'!
initalize

	super initialize.
	
	color := Color blue.
	self position: 250@100! !

!DroppedMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/14/2008 21:47'!
rejectDropMorphEvent: anEvent

	| h |
	h := anEvent hand.
	WorldState
		addDeferredUIMessage: [h grabMorph: self].
	anEvent wasHandled: true! !

Morph subclass: #ReceiverMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SBE-Morphic'!

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/14/2008 21:33'!
initialize

	super initialize.
	color := Color red.
	bounds := 0@0 corner: 200@200! !

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/14/2008 21:35'!
repelsMorph: aMorph event: ev

	^(self wantsDroppedMorph: aMorph event: ev) not! !

!ReceiverMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/14/2008 21:36'!
wantsDroppedMorph: aMorph event: anEvent

	^ aMorph color = Color blue! !

Morph subclass: #VendingMachineProductRailMorph
	instanceVariableNames: 'productName price buyProduct'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-VendingMachine'!

!VendingMachineProductRailMorph methodsFor: 'as yet unclassified' stamp: 'hjo 4/25/2007 07:04'!
initialize

	super initialize.
	self addMorph: ((productName := StringMorph new)position: 0 @ 0).
	self addMorph: ((price := StringMorph new)position: 0 @ 20).
	self addMorph: ((buyProduct := PluggableButtonMorph new)position: 0 @ 40)! !

!VendingMachineProductRailMorph methodsFor: 'as yet unclassified' stamp: 'hjo 4/25/2007 07:04'!
model: aVendingMachineProductRail

	productName contents: aVendingMachineProductRail productName.
	price contents: aVendingMachineProductRail price printString.
	buyProduct on: aVendingMachineProductRail getState: #canBeSold action: #buyProduct label: #buttonLabel menu: nil! !

BorderedMorph subclass: #DieMorph
	instanceVariableNames: 'faces dieValue isStopped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SBE-Morphic'!

!DieMorph classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 16:47'!
faces: aNumber

	^ self new faces: aNumber! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:15'!
dieValue: aNumber

	(aNumber isInteger and: [
		aNumber > 0 and: [
			aNumber <= faces ]])
		ifTrue: [ dieValue := aNumber. self changed ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:09'!
drawDotOn: aCanvas at: aPoint

	aCanvas
		fillOval: (Rectangle
			center: self position + (self extent * aPoint)
			extent: self extent / 6)
		color: Color black! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 18:12'!
drawOn: aCanvas

	| theCanvas |
	theCanvas := aCanvas asAlphaBlendingCanvas: 0.5.
	
	super drawOn: theCanvas.
	(self perform: ('face' , dieValue asString) asSymbol)
		do: [:aPoint| self drawDotOn: theCanvas at: aPoint]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:03'!
face1

	^ {0.5@0.5}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:03'!
face2

	^ {0.25@0.25 . 0.75@0.75}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:04'!
face3

	^ {0.25@0.25 . 0.75@0.75. 0.5@0.5}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:19'!
face4

	^ {0.25@0.25 . 0.75@0.75. 0.75@0.25. 0.25@0.75}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:05'!
face5

	^ {0.25@0.25 . 0.75@0.75. 0.5@0.5. 0.75@0.25. 0.25@0.75}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:20'!
face6

	^ {0.25@0.25 . 0.75@0.75. 0.75@0.5.  0.75@0.25. 0.25@0.75.  0.25@0.5}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:22'!
face7

	^ {0.25@0.25 . 0.75@0.75. 0.75@0.5.  0.75@0.25. 0.25@0.75.  0.25@0.5 .  0.5@0.5}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:22'!
face8

	^ {0.25@0.25 . 0.75@0.75. 0.75@0.5.  0.75@0.25. 0.25@0.75.  0.25@0.5 .  0.5@0.5 . 0.5@0.25}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:23'!
face9

	^ {0.25@0.25 . 0.75@0.75. 0.75@0.5.  0.75@0.25. 0.25@0.75.  0.25@0.5 .  0.5@0.5 . 0.5@0.25.  0.5@0.75}! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 16:53'!
faces: aNumber

	"Set the number of faces"
	(aNumber isInteger and: [
	aNumber > 0 and: [
	aNumber <= 9 ]])
		ifTrue: [faces := aNumber]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:26'!
handlesMouseDown: anEvent

	^ true! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 16:50'!
initialize

	super initialize.
	self extent: 50 @ 50.
	self useGradientFill; borderWidth: 2; useRoundedCorners.
	self setBorderStyle: #complexRaised.
	self fillStyle direction: self extent.
	self color: Color green.
	dieValue := 1.
	faces := 6.
	isStopped := false! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:27'!
mouseDown: anEvent

	anEvent redButtonPressed
		ifTrue: [ isStopped := isStopped = false ]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:24'!
step

	isStopped ifTrue: [self dieValue: (1 to: faces) atRandom]! !

!DieMorph methodsFor: 'as yet unclassified' stamp: 'hjo 3/15/2008 17:23'!
stepTime

	^ 100! !

TestCase subclass: #CopyConcatenateRollTestCase
	instanceVariableNames: 'array juggle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:31'!
setUp
	super setUp.
	array := Array withAll: #(1 2 3 4 5 6 7 8 9 ).
	(juggle := CopyConcatenatingRoll new) array: array! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftLeft1

	juggle shiftLeft: 1.
	self assert: array = #(2 3 4 5 6 7 8 9 1)! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftLeft2

	juggle shiftLeft: 2.
	self assert: array = #(3 4 5 6 7 8 9 1 2)! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftLeft3

	juggle shiftLeft: 3.
	self assert: array = #(4 5 6 7 8 9 1 2 3)! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftRight1

	juggle shiftRight: 1.
	self assert: array = #(9 1 2 3 4 5 6 7 8)! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftRight2

	juggle shiftRight: 2.
	self assert: array = #(8 9 1 2 3 4 5 6 7)! !

!CopyConcatenateRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/10/2007 14:30'!
testShiftRight3

	juggle shiftRight: 3.
	self assert: array = #(7 8 9 1 2 3 4 5 6)! !

TestCase subclass: #FileSyncSideTest
	instanceVariableNames: 'o'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSideTest methodsFor: 'private' stamp: 'hjo 1/1/2008 23:20'!
answerForFullPathTest

	^'ab' , FileDirectory slash , 'cd'! !

!FileSyncSideTest methodsFor: 'running' stamp: 'hjo 1/1/2008 23:16'!
setUp

	super setUp.
	o := FileSyncSide new.
! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/5/2008 01:19'!
testIsFolder

	o path: 'root'.
	o itemName: 'folder'.
	self assert: (o isFolderContext: nil)! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:20'!
testSyncSide

	o path: 'ab'.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:21'!
testSyncSide2

	o path: 'ab'.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:29'!
testSyncSide3

	o path: 'ab' , FileDirectory slash.
	o itemName: 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

!FileSyncSideTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:43'!
testSyncSide4

	o path: 'ab' , FileDirectory slash.
	o itemName: FileDirectory slash , 'cd'.
	self assert: o fullPath = self answerForFullPathTest! !

TestCase subclass: #FileSyncTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:46'!
testDestinationSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs destinationSide fullPath = ('des' , FileDirectory slash , 'ff').
	! !

!FileSyncTest methodsFor: 'testing' stamp: 'hjo 1/1/2008 23:09'!
testReferenceSide

	| fs |
	fs := FileSync from: 'refe' to: 'des' for: 'ff'.
	self assert: fs referenceSide fullPath = ('refe' , FileDirectory slash , 'ff').
	! !

TestCase subclass: #JuggleRollTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:32'!
testDifficultLeft

	| j |
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by: 4.
	self assert:j array = #(5 6 7 8 9 10 11 1 2 3 4)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:32'!
testDifficultRight

	"|j|
	j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)).
	j shiftRight: 4."
	| j |
	j := RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by: 4.
	self assert:j array = #(8 9 10 11 1 2 3 4 5 6 7)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:33'!
testEasyOne

	"|j|
	j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4)).
	j shiftLeft: 3."
	|j|
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4)) by: 3.
	self assert:j array = #(4 1 2 3)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:34'!
testMediumOne

	"|j|
	j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4 5)).
	j shiftLeft: 3."
	| j |
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5)) by: 3.
	self assert:j array = #(4 5 1 2 3)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:12'!
testRollAroundLeft

	|array|
	array := Array withAll: #(1 2 3 4 5).
	LeftJuggleRoll on: array by: 5.
	self assert: array = #(1 2 3 4 5).
	LeftJuggleRoll on: array by: 6.
	self assert: array = #(2 3 4 5 1)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:15'!
testRollAroundRight

	|array|
	array := Array withAll: #(1 2 3 4 5).
	RightJuggleRoll on: array by: 5.
	self assert: array = #(1 2 3 4 5).
	RightJuggleRoll on: array by: 6.
	self assert: array = #(5 1 2 3 4)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:35'!
testShiftLeft1

	"|j|
	j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)).
	j shiftLeft:1."
	|j|
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 1.
	self assert: j array = #(2 3 4 5 6 7 8 9 10 1)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:35'!
testShiftLeft2

	"|j|
	j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)).
	j shiftLeft:2."
	| j |
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 2.
	self assert: j array = #(3 4 5 6 7 8 9 10 1 2)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:37'!
testShiftLeft5

	|j|
	"j := JuggleBothWayRoll new.
	j array: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)).
	j shiftLeft:5."
	j := LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 5.
	self assert: j array = #(6 7 8 9 10 1 2 3 4 5)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:16'!
testShiftLeftIndexOff1setFromTo

	self assert: (LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by: 2 indexOffset: 1 from: 3 to: 8) array = #(1 2 5 4 7 6 3 8 9 10 11)! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:05'!
testShiftLeftIndexOff2setFromTo

	self assert: (LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by: 2 indexOffset: 2 from: 3 to: 8) array = #(1 2 3 6 5 8 7 4 9 10 11)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:05'!
testShiftLeftIndexOffset1

	self assert: (LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by: 3 indexOffset: 1) array = #(4 2 3 7 5 6 1 8 9)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:06'!
testShiftLeftIndexOffset2

	self assert: ((LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by: 3 indexOffset: 2)) array = #(1 5 3 4 8 6 7 2 9)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:06'!
testShiftLeftIndexOffset3

	self assert: (LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by: 3 indexOffset: 3) array = #(1 2 6 4 5 9 7 8 3)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:07'!
testShiftRight1

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 1) array = #(10 1 2 3 4 5 6 7 8 9)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:07'!
testShiftRight2

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 2) array = #(9 10 1 2 3 4 5 6 7 8)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:07'!
testShiftRight5

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10)) by: 5) array = #(6 7 8 9 10 1 2 3 4 5)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:07'!
testShiftRightIndexOff1setFromTo

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by: 2 indexOffset: 1 from: 3 to: 8) array = #(1 2 3 8 5 4 7 6 9 10 11)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:08'!
testShiftRightIndexOff2setFromTo

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9 10 11)) by:2 indexOffset: 2 from: 3 to: 8) array = #(1 2 7 4 3 6 5 8 9 10 11)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:08'!
testShiftRightIndexOffset1

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by:3 indexOffset: 1) array = #(1 2 9 4 5 3 7 8 6)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:09'!
testShiftRightIndexOffset2

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by:3 indexOffset: 2) array = #(1 8 3 4 2 6 7 5 9)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:09'!
testShiftRightIndexOffset3

	self assert: (RightJuggleRoll on: (Array withAll: #(1 2 3 4 5 6 7 8 9)) by:3 indexOffset: 3) array = #(7 2 3 1 5 6 4 8 9)
! !

!JuggleRollTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 9/22/2007 10:09'!
testZeroRoll

	self assert: (LeftJuggleRoll on: (Array withAll: #(1 2 3 4 5)) by: 0) array = #(1 2 3 4 5)! !

TestCase subclass: #MagicSquareAlgorithmTestCase
	instanceVariableNames: 'al'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!MagicSquareAlgorithmTestCase methodsFor: 'running' stamp: 'hjo 12/17/2007 14:23'!
setUp

	super setUp.
	al := MagicSquareAlgorithm new.
	al reset! !

!MagicSquareAlgorithmTestCase methodsFor: 'testing' stamp: 'hjo 12/19/2007 11:39'!
test3x3

	al resetNByN: 3.
	al run.
	self assert: al answers size = 8! !

!MagicSquareAlgorithmTestCase methodsFor: 'testing' stamp: 'hjo 12/17/2007 23:55'!
testSteps

	| testBlock |
	testBlock := [:x| 
		self assert: al answers isEmpty.
		self assert: al stackSize = x].

	testBlock value: 1.
	#(9 12 11 11 10 10 9 10 9 8) copy
		do: [:sts| 
		al step.
		testBlock value: sts.
	]! !

TestCase subclass: #MagicSquareTestCase
	instanceVariableNames: 'magicSquare'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!MagicSquareTestCase methodsFor: 'running' stamp: 'hjo 12/12/2007 18:28'!
setUp

	super setUp.
	magicSquare := MagicSquare new! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/17/2007 14:15'!
testBoardDiagonals

	magicSquare board: (Matrix rows: 3 columns: 3 contents: #(1 2 3 4 5 6 7 8 9) copy ).
	self assert: magicSquare boardDiagonals = #(#(1 5 9) #(3 5 7))! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:34'!
testHasNoDuplicateNumbers

	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 nil nil nil 3 nil nil nil nil) ).
	self assert: magicSquare hasNoDuplicateNumbers.
	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 nil nil nil 3 nil nil 3 nil) ).
	self deny: magicSquare hasNoDuplicateNumbers.
	! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:46'!
testIsAmbiguous

	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 nil nil nil 3 nil nil nil nil) ).
	self assert: magicSquare isAmbiguous.
	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 2 4 5 3 6 7 1 2) ).
	self deny: magicSquare isAmbiguous.
	! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:58'!
testIsCorrectSoFar

	magicSquare initialize3x3.
	self assert: magicSquare isCorrectSoFar.
	
	magicSquare set: 1 onBoardAt: 1@1.
	self assert: magicSquare isCorrectSoFar! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:47'!
testIsNumberInBetween

	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 2 3 4 5 6 9 nil nil) ).
	self assert: magicSquare isNumberInBetween
.
	magicSquare board: ( Matrix rows: 3 columns: 3 contents: #(1 2 4 5 3 60 7 1 2) ).
	self deny: magicSquare isNumberInBetween
.
	! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:52'!
testSideSumCorrect

	magicSquare board: (Matrix rows: 3 columns: 3 contents: #(1 2 3 4 5 6 7 8 9)).
	self deny: magicSquare sideSumCorrect.
	
	magicSquare board: (Matrix rows: 3 columns: 3 contents: #(8 5 2 nil nil nil nil nil nil)).
	self assert: magicSquare sideSumCorrect.! !

!MagicSquareTestCase methodsFor: 'testing' stamp: 'hjo 12/17/2007 14:19'!
testVectors

	magicSquare board: (Matrix rows: 3 columns: 3 contents: (1 to: 9)).
	self assert: magicSquare vectors = #(#(1 2 3) #(4 5 6) #(7 8 9) #(1 4 7) #(2 5 8) #(3 6 9) #(1 5 9) #(3 5 7))! !

TestCase subclass: #MaxClubTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Maxclub'!

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForNumbers

	|mc|
	mc := MaxClub forNumbers.
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		(5 true 1 5)
		(5 true 2 5)
		(3 false 2 5)	
		(7 true 1 7)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]! !

!MaxClubTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:33'!
testForOddCounting

	|mc|
	mc := MaxClub new.
	mc evaluator: [:x| (x select: [:each| each odd]) size ].
	self assert: mc members size = 0.
	self assert: mc maximum = nil.
	#(
		((2 4) true 1 0)
		((1 2 4) true 1 1)
		((1 2 4) true 2 1)
		((1 2 3 4) true 1 2)
		((0 2 3 4) false 1 2)
	)
		do: [:array| |stream| stream := array readStream.
			self assert: (mc put: stream next) = stream next.
			self assert: mc members size = stream next.
			self assert: mc maximum = stream next.
		]
! !

TestCase subclass: #SICPdriverTest
	instanceVariableNames: 'b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SICP'!

!SICPdriverTest methodsFor: 'as yet unclassified' stamp: 'hjo 2/4/2008 12:58'!
bStackPushSicpEx100

	b stack push: SICP ex100.! !

!SICPdriverTest methodsFor: 'initializing' stamp: 'hjo 2/4/2008 12:55'!
setUp

	super setUp.
	b := SICPdriver new.! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 2/4/2008 12:55'!
testRun

	b stack push: SICP ex100.

	b run.
	self assert: b answers size = 4
! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 2/4/2008 12:55'!
testRunToFindOneAnswer

	b stack push: SICP ex100.
	
	self assert: b answers size = 0.
	b runToFindOneAnswer.
	self assert: b answers size = 1! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 2/4/2008 13:47'!
testStackContents

	self assert: b stackIsEmpty.
	self assert: b stackContents = ''.	
	
	b stack push: SICP ex100.
	self assert: b stackContents =  'a SICP(0 0 0 100)
'! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 2/4/2008 12:56'!
testStackIsEmpty

	self assert: b stackIsEmpty.
	b stack push: SICP ex100.
	self deny: b stackIsEmpty
	
	! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 2/4/2008 12:56'!
testStep

	self assert: b stackIsEmpty.
	b stack push: SICP ex100.

	self assert: b answers size = 0.
	self assert: b stack size = 1.
	b step.
	self assert: b answers size = 1.
	self assert: b stack size = 2.
! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 3/16/2008 22:07'!
testStep0

	| one |
	self assert: b stackIsEmpty.
	b stack push: SICP ex100.

	self assert: b answers size = 0.
	self assert: b stack size = 1.
	one := b stack linkedList first element.
	self assert: one c100 = 0.
	self assert: one c50 = 0.
	self assert: one c10 = 0.
	self assert: one remain = 100! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 3/16/2008 22:11'!
testStep1

	| one |
	self assert: b stackIsEmpty.
	b stack push: SICP ex100.

	b step.
	
	self assert: b answers size = 1.
	self assert: b stack size = 2.

	one := b stack linkedList first element.
	self assert: one c100 = 0.
	self assert: one c50 = 0.
	self assert: one c10 = 1.
	self assert: one remain = 90.
	
	one := b stack linkedList second element.
	self assert: one c100 = 0.
	self assert: one c50 = 1.
	self assert: one c10 = 0.
	self assert: one remain = 50! !

!SICPdriverTest methodsFor: 'tests' stamp: 'hjo 3/16/2008 22:19'!
testStep2

	| one |
	self assert: b stackIsEmpty.
	b stack push: SICP ex100.

	b step.
	b step.
	
	self assert: b answers size = 1.
	self assert: b stack size = 3.

	one := b stack linkedList first element.
	self assert: one c100 = 0.
	self assert: one c50 = 0.
	self assert: one c10 = 2.
	self assert: one remain = 80.
	
	one := b stack linkedList second element.
	self assert: one c100 = 0.
	self assert: one c50 = 1.
	self assert: one c10 = 1.
	self assert: one remain = 40.

	one := b stack linkedList third element.
	self assert: one c100 = 0.
	self assert: one c50 = 1.
	self assert: one c10 = 0.
	self assert: one remain = 50
! !

TestCase subclass: #SICPtest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SICP'!

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/15/2008 18:54'!
testC10

	| o |
	o := SICP ex100.
	self assert: o c10 = 0.
	o c10: 1.
	self assert: o c10 = 1! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/15/2008 18:29'!
testC100

	| o |
	o := SICP ex100.
	self assert: o c100 = 0.
	o c100: 1.
	self assert: o c100 = 1! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/15/2008 21:18'!
testC50

	| o |
	o := SICP ex100.
	self assert: o c50 = 0.
	o c50: 1.
	self assert: o c50 = 1! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 3/16/2008 21:32'!
testCoinCopy

	| a c |
	a := SICP ex100.
	c := a coinCopy.
	
	self assert: a c10 = c c10.
	self assert: a c50 = c c50.
	self assert: a c100 = c c100.
	
	self assert: a coinTypes == c coinTypes.
	self deny: a coins == c coins! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:37'!
testCoinSum

	| o |
	o := SICP ex100.
	self assert: o coinSum = 0.
	self assert: o variationC100 coinSum = 100.
	self assert: o variationC50 coinSum = 50.
	self assert: o variationC10 coinSum = 10! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 23:09'!
testEqual

	self assert: SICP ex100 = SICP ex100. 
	self deny: SICP ex100 = (SICP ex100 c100: 1).
	self deny: SICP ex100 = (SICP ex100 c50: 2).
	self deny: SICP ex100 = (SICP ex100 c10: 3).
	self deny: SICP ex100 = (SICP ex100 remain: 4)! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:32'!
testIsSolved

	self deny: SICP ex100 isSolved.
	self assert: SICP ex100 variationC100 isSolved! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:57'!
testNormal

	self assert: SICP ex100 isNormal.
	self deny: (SICP ex100 c100: -1; yourself) isNormal.
	self deny: (SICP ex100 c50: -1; yourself) isNormal.
	self deny: (SICP ex100 c10: -1; yourself) isNormal.
	self deny: (SICP ex100 remain: -1; yourself) isNormal
	! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:35'!
testRemain

	| o |
	o := SICP ex100.
	self assert: o remain = 100.
	self assert: o variationC100 remain = 0.
	self assert: o variationC50 remain = 50.
	self assert: o variationC10 remain = 90! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:44'!
testSum

	| o |
	o := SICP ex100.
	self assert: o sum = 100.
	self assert: o variationC100 sum = 100.
	self assert: o variationC50 sum = 100.
	self assert: o variationC10 sum = 100! !

!SICPtest methodsFor: 'tests' stamp: 'hjo 2/2/2008 22:50'!
testVariations

	self assert: SICP ex100 variations size = 3.	
	self assert: SICP ex100 variationC50 variations size = 2! !

TestCase subclass: #VendingMachineTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-VendingMachine'!

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:52'!
testCanBeSold

	|m|
	m := VendingMachine new.
	self deny: (m productRails at:1) canBeSold.
	self deny: (m productRails at:2) canBeSold.
	self deny: (m productRails at:3) canBeSold.
	m insertCoin500.
	self deny: (m productRails at:1) canBeSold.
	self assert: (m productRails at:2) canBeSold.
	self deny: (m productRails at:3) canBeSold.
	m insertCoin100.
	m insertCoin100.
	self deny: (m productRails at:1) canBeSold.
	self assert: (m productRails at:2) canBeSold.
	self assert: (m productRails at:3) canBeSold.
	m insertCoin100.
	self assert: (m productRails at:1) canBeSold.
	self assert: (m productRails at:2) canBeSold.
	self assert: (m productRails at:3) canBeSold.
	(m productRails at:2) buyProduct.
	self deny: (m productRails at:1) canBeSold.
	self deny: (m productRails at:2) canBeSold.
	self deny: (m productRails at:3) canBeSold! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:53'!
testCanBeSoldForStock

	|m|
	m := VendingMachine new.
	m insertedMoney: 10000.
	self assert: (m productRails at:1) canBeSold.
	(m productRails at:1) stock: 0.
	self deny: (m productRails at:1) canBeSold.
	(m productRails at:1) addOneProduct.
	self assert: (m productRails at:1) canBeSold! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:53'!
testCoins

	|m|
	m := VendingMachine new.
	self assert: m coins isEmpty.
	m insertCoin10.
	self assert: m coins asSortedCollection = (SortedCollection with: 10).
	m insertCoin10.
	self assert: m coins asSortedCollection = (SortedCollection with: 10 with: 10).
	m insertCoin50.
	self assert: m coins asSortedCollection = (SortedCollection with: 10 with: 10 with: 50).
	m insertCoin100.
	self assert: m coins asSortedCollection = (SortedCollection with: 10 with: 10 with: 50 with: 100).
	m insertCoin500.
	self assert: m coins asSortedCollection = (SortedCollection with: 10 with: 10 with: 50 with: 100 with: 500).
	m emptyCoins.
	self assert: m coins isEmpty! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:28'!
testEnterSmallMoneyOneBuyProduct

	|m|
	m := VendingMachine new.
	m insertCoin100.
	m insertCoin100.
	m insertCoin100.
	m insertCoin500.
	m insertCoin10.
	self assert: (m insertedMoney = 810).
	(m productRails at:1) buyProduct.
	self assert: (m insertedMoney = 10).
	self assert: (m changeBox isEmpty).
	m returnChange.
	self assert: (m changeBox asSortedCollection = (SortedCollection with:10))! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:20'!
testReturnChange

	
	|m p|
	m := VendingMachine new.
	10 timesRepeat: [m insertCoin100].
	p := m productRails at:1.
	self assert: (p price = 800).
	p buyProduct.
	self assert: (m insertedMoney = 200).
	self assert: (m changeBox isEmpty).
	m returnChange.
	self assert: (m insertedMoney = 0).
	self assert: (m changeBox asArray = #(100 100))! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:24'!
testReturnChangeRollBack

	
	|m|
	m := VendingMachine new.
	m coins: #(100 100) asBag.
	m insertedMoney: 250.
	self assert: (m changeBox isEmpty).
	self should: [m returnChange] raise: Error.
	self assert: (m insertedMoney = 250).
	self assert: (m coins asArray = #(100 100)).
	self assert: (m changeBox isEmpty)! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:53'!
testSetPrice

	|m|
	m := VendingMachine new.
	m insertedMoney: 500.
	self assert: (m productRails at: 2) canBeSold.
	(m productRails at: 2) price: 1000.
	self deny: (m productRails at: 2) canBeSold! !

!VendingMachineTestCase methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:54'!
testZeroInsertedMoney

	|m|
	m := VendingMachine new.
	m insertedMoney: 500.
	self deny: m insertedMoney isZero.
	m zeroInsertedMoney.
	self assert: m insertedMoney isZero! !

SystemWindow subclass: #VendingMachineWindow
	instanceVariableNames: 'insertCoin500 insertCoin100 insertCoin50 insertCoin10 insertedMoney cancel changeBox emptyChangeBox emptyBottomCompartment bottomCompartment productRails'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-VendingMachine'!

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/25/2007 07:37'!
initialize

	super initialize.
	self initializeCoinButtons.
	self initializeProductRails.
	self initializeChangeBox.
	self initializeBottomCompartment.
	self initializeOpenFrontPanelButton.
	self initializeInsertedCoinDisplay.
	self setLabel: 'Vending Machine ver 0.7'.! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/24/2007 04:30'!
initializeBottomCompartment

	self addMorph: (emptyBottomCompartment := PluggableButtonMorph new
		position: 10 @ 330 ;
		label: 'Empty bottom comparment';
		extent: 100 @ 200;
		yourself).

	self addMorph:
		((bottomCompartment := PluggableListMorph on: #('kin sidar' 'moca cola' 'zealot tea') list: #yourself selected: nil changeSelected: nil)
		position: 20 @ 198)! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/24/2007 04:25'!
initializeChangeBox

	self addMorph: (emptyChangeBox := PluggableButtonMorph new
		position: 190 @ 330 ;
		label: 'Empty change box';
		extent: 100 @ 200;
		yourself).

	self addMorph:
		(changeBox := (PluggableListMorph new)
		position: 180 @ 198)
! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/24/2007 04:11'!
initializeCoinButtons

	self addMorph: ((insertCoin500 := PluggableButtonMorph new)
		position: 12 @ 123;
		label: '500 won';
		extent: 100 @ 200).

	self addMorph: ((insertCoin100 := PluggableButtonMorph new)
		position: 72 @ 123;
		label: '100 won';
		extent: 100 @ 200).

	self addMorph: ((insertCoin50 := PluggableButtonMorph new)
		position: 12 @ 145;
		label: '50 won';
		extent: 100 @ 200).

	self addMorph: ((insertCoin10 := PluggableButtonMorph new)
		position: 72 @ 145;
		label: '10 won';
		extent: 100 @ 200).

	self addMorph: ((cancel := PluggableButtonMorph new)
		position: 140 @ 123;
		label: 'cancel';
		extent: 100 @ 200).
! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/23/2007 21:20'!
initializeInsertedCoinDisplay.

	self addMorph: 
		(insertedMoney := StringMorph new 
			contents: '0'; 
			position: 270 @ 150;
			yourself)! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/23/2007 09:40'!
initializeOpenFrontPanelButton

	self addMorph: (PluggableButtonMorph new
		position: 240 @ 370 ;
		label: 'open front panel';
	     extent: 100 @ 200;
		yourself)! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/25/2007 06:11'!
initializeProductRails

	self initializeProductRailsNew! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/25/2007 06:24'!
initializeProductRailsNew

	productRails := OrderedCollection new.
	productRails addLast: (VendingMachineProductRailMorph new position: 20 @ 20; extent: 70 @ 80; color: Color gray).
	productRails addLast: (VendingMachineProductRailMorph new position: 100 @ 20; extent: 70 @ 80; color: Color gray).
	productRails addLast: (VendingMachineProductRailMorph new position: 180 @ 20; extent: 70 @ 80; color: Color gray).
	productRails do: [:each| self addMorph: each].! !

!VendingMachineWindow methodsFor: 'geometry' stamp: 'hjo 4/25/2007 06:10'!
initializeProductRailsOld

#(#(10 80 'buy')
#(120 80 'buy')
#(230 80 'buy')
)
 do: [:data| self addMorph: (PluggableButtonMorph new
 position: data first @ data second ;
 label: data third;
     extent: 100 @ 200;
 yourself)].
#(#('Mocca Cola'  10 40) #('800' 10 60) #('Zealot Tea' 120 40) #('500' 120 60)
#('Kin Cidar' 230 40) #('650' 230 60) )
do: [:data|
  self addMorph: 
       (StringMorph new 
            contents: data first; 
            position: data second @ data third;
            yourself)
].! !

!VendingMachineWindow methodsFor: 'accessing' stamp: 'hjo 4/25/2007 06:24'!
model: aVendingMachine

	super model: aVendingMachine.
	self wireModel.
	insertCoin500 on: self model getState: nil action: #insertCoin500 label: nil menu: nil.
	insertCoin100 on: self model getState: nil action: #insertCoin100 label: nil menu: nil.
	insertCoin50 on: self model getState: nil action: #insertCoin50 label: nil menu: nil.
	insertCoin10 on: self model getState: nil action: #insertCoin10 label: nil menu: nil.
	cancel on: self model getState: nil action: #returnChange label: nil menu: nil.
	changeBox on: self model list: #changeBoxAsArray selected: nil changeSelected: nil menu: nil keystroke: #arrowKey:from:.
	emptyChangeBox on: self model getState: nil action: #emptyChangeBox label: nil menu: nil.
	emptyBottomCompartment on: self model getState: nil action: #emptyBottomCompartment label: nil menu: nil.
	bottomCompartment on: self model list: #bottomCompartmentAsArray selected: nil changeSelected: nil menu: nil keystroke: #arrayKey:from:.
	productRails first model: self model productRails first.
	productRails second model: self model productRails second.
	productRails third model: self model productRails third.! !

!VendingMachineWindow methodsFor: 'events' stamp: 'hjo 4/24/2007 04:30'!
onBottomCompartmentChanged

	bottomCompartment updateList! !

!VendingMachineWindow methodsFor: 'events' stamp: 'hjo 4/24/2007 04:21'!
onChangeBoxChanged

	changeBox updateList! !

!VendingMachineWindow methodsFor: 'events' stamp: 'hjo 4/24/2007 04:24'!
onCoinsChanged

	"coins updateList"! !

!VendingMachineWindow methodsFor: 'events' stamp: 'hjo 4/23/2007 21:22'!
onInsertedMoneyChanged

	insertedMoney contents: self model insertedMoney printString! !

!VendingMachineWindow methodsFor: 'events' stamp: 'hjo 4/23/2007 09:40'!
openInWorld: aWorld

	super openInWorld: aWorld.
	self extent:  355 @ 400.! !

!VendingMachineWindow methodsFor: 'accessing - properties' stamp: 'hjo 4/23/2007 21:18'!
wireModel

	self model when: #insertedMoneyChanged send: #onInsertedMoneyChanged to: self.
	self model when: #changeBoxChanged send: #onChangeBoxChanged to: self.
	self model when: #bottomCompartmentChanged send: #onBottomCompartmentChanged to: self.
	self model when: #coinsChanged send: #onCoinsChanged to: self.! !

Object subclass: #AbstractWoodCutPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:47'!
above: aWoodCutPicture 

	^PictureAbovePicture new
		upPicture: self;
		downPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:51'!
beside: aWoodCutPicture 

	^PictureBesidePicture new
		leftPicture: self;
		rightPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 21:20'!
buildCorner: aWoodCutPicture

	PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: "side"0;
		lowerLeftPicture: "side" 0 rotated;
		lowerRightPicture: aWoodCutPicture tileU! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 20:44'!
buildSide: aWoodCutPicture

	^PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: self;
		lowerLeftPicture: aWoodCutPicture rotated;
		lowerRightPicture: aWoodCutPicture	! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 09:51'!
cycleOfOne

	^PictureCycle new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:31'!
cycled

	^PictureCycle new picture: self! !

!AbstractWoodCutPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:47'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 
 
	self subclassResponsibility! !

!AbstractWoodCutPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:35'!
drawOnWorld

	self drawOnCanvas: World canvas usingFrame: DaliotsFrame default! !

!AbstractWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:00'!
expressionString

	^String streamContents: [:stream| self printExpressionOn: stream ]! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:28'!
flipped

	^FlippedPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:12'!
over: aWoodCutPicture 

	^PictureOverPicture new
		overPicture: self;
		underPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:32'!
pattern2

	^self rotatedBy45Degrees flipped! !

!AbstractWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 17:58'!
printExpressionOn: aStream

	self subclassResponsibility! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:40'!
quartetOfOne

	^PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: self;
		lowerLeftPicture: self;
		lowerRightPicture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:29'!
rotated
	
	^RotatedPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:52'!
rotatedBy45Degrees

	^RotatedBy45DegreesPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:10'!
sierpinskiDepth

	^0! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/13/2008 19:36'!
sierpinskiForm

	^SierpinskiPicture new subPicture: self; blank: WoodCutPicture blank! !

!AbstractWoodCutPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 13:59'!
simplified

	^self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/6/2008 16:48'!
tileTForm

	^WoodCutTileT new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/6/2008 16:48'!
tileUForm

	^WoodCutTileU new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:38'!
tileVForm

	^WoodCutTileV new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:37'!
triplyRotated

	^self rotated rotated rotated! !

!AbstractWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:04'!
unitPicture

	^self! !

AbstractWoodCutPicture subclass: #FunctionalWoodCutPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:48'!
functionName

	^self subclassResponsibility! !

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:49'!
parameterList

	"Answer an array of pictures used as parameters"
	^self subclassResponsibility! !

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:47'!
printExpressionOn: aStream

	aStream nextPutAll: self functionName.
	aStream nextPut: $(.
	
	self parameterList
		do: [:pict| pict printExpressionOn: aStream ] separatedBy: [ aStream nextPut: $, ].

	aStream nextPut: $)! !

FunctionalWoodCutPicture subclass: #PictureAbovePicture
	instanceVariableNames: 'upPicture downPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 20:32'!
downPicture: aWoodCutPicture 

	downPicture :=aWoodCutPicture! !

!PictureAbovePicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:30'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	upPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame upHalf.
	downPicture drawOnCanvas:aCanvas usingFrame: aDaliotsFrame downHalf ! !

!PictureAbovePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:02'!
functionName 

	^'above'! !

!PictureAbovePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:04'!
parameterList

	^{ upPicture. downPicture }! !

!PictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 20:32'!
upPicture: aWoodCutPicture 

	upPicture := aWoodCutPicture! !

PictureAbovePicture subclass: #WeightedPictureAbovePicture
	instanceVariableNames: 'upWeight downWeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WeightedPictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 10:02'!
downWeight: aNumber

	downWeight := aNumber! !

!WeightedPictureAbovePicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 12:00'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	| weightedYVector |
	weightedYVector := aDaliotsFrame yVectorWeightedBy: upWeight and: downWeight.
	upPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame upPart: weightedYVector).
	downPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame downPart: weightedYVector)! !

!WeightedPictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 10:01'!
upWeight: aNumber

	upWeight := aNumber! !

FunctionalWoodCutPicture subclass: #PictureBesidePicture
	instanceVariableNames: 'leftPicture rightPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureBesidePicture methodsFor: 'drawing' stamp: 'hjo 3/5/2008 17:14'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	leftPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame leftHalf.
	rightPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rightHalf! !

!PictureBesidePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:05'!
functionName

	^'beside'! !

!PictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 05:32'!
leftPicture: aWoodCutPicture 

	leftPicture :=aWoodCutPicture! !

!PictureBesidePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:06'!
parameterList

	^{ leftPicture. rightPicture }! !

!PictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 05:32'!
rightPicture: aWoodCutPicture 

	rightPicture :=aWoodCutPicture! !

PictureBesidePicture subclass: #WeightedPictureBesidePicture
	instanceVariableNames: 'leftWeight rightWeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WeightedPictureBesidePicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 11:58'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	| weightedXVector |
	weightedXVector := aDaliotsFrame xVectorWeightedBy: leftWeight and: rightWeight.
	leftPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame leftPart: weightedXVector).
	rightPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame rightPart: weightedXVector)! !

!WeightedPictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 3/5/2008 17:12'!
leftWeight: aNumber

	leftWeight :=aNumber! !

!WeightedPictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 3/5/2008 17:13'!
rightWeight: aNumber

	rightWeight :=aNumber! !

FunctionalWoodCutPicture subclass: #PictureNonet
	instanceVariableNames: 'northWest north northEast west middle east southWest south southEast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureNonet methodsFor: 'drawing' stamp: 'hjo 3/5/2008 17:20'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame
! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:58'!
east

	^ east! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
east: aWoodCutPicture

	east := aWoodCutPicture! !

!PictureNonet methodsFor: 'creation' stamp: 'hjo 3/6/2008 11:34'!
equivalentExpression

	^WeightedPictureAbovePicture new
		upWeight: 1;
		downWeight: 2;
		upPicture: (self equivalentExpressionRowWith: northWest with: north with: northEast);
		downPicture: 
			(PictureAbovePicture new
				upPicture: (self equivalentExpressionRowWith: west with: middle with: east);
				downPicture: (self equivalentExpressionRowWith: southWest with: south with: southEast)
			)
		! !

!PictureNonet methodsFor: 'creation' stamp: 'hjo 3/6/2008 11:23'!
equivalentExpressionRowWith: picture1 with: picture2 with: picture3
		
	^WeightedPictureBesidePicture new
		leftWeight: 1;
		rightWeight: 2;
		leftPicture: picture1;
		rightPicture: 
			(PictureBesidePicture new
				leftPicture: picture2;
				rightPicture: picture3
			)
		! !

!PictureNonet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:07'!
functionName

	^'nonet'! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
middle

	^ middle! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
middle: aWoodCutPicture

	middle := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
north

	^ north! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
north: aWoodCutPicture

	north := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northEast

	^ northEast! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northEast: aWoodCutPicture

	northEast := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northWest

	^ northWest! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
northWest: aWoodCutPicture

	northWest := aWoodCutPicture! !

!PictureNonet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:08'!
parameterList

	^{ northWest. north. northEast.
	   west.  middle.  east.
	   southWest. south. southEast }! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
south

	^ south! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
south: aWoodCutPicture

	south := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
southEast

	^ southEast! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southEast: aWoodCutPicture

	southEast := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southWest

	^ southWest! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southWest: aWoodCutPicture

	southWest := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
west

	^ west! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
west: anObject

	west := anObject! !

FunctionalWoodCutPicture subclass: #PictureOverPicture
	instanceVariableNames: 'overPicture underPicture frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureOverPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:33'!
drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame 

	underPicture drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame.
	overPicture drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame ! !

!PictureOverPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:09'!
functionName

	^'over'! !

!PictureOverPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 08:39'!
overPicture: aWoodCutPicture 

	overPicture :=aWoodCutPicture! !

!PictureOverPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:10'!
parameterList

	^{overPicture. underPicture}! !

!PictureOverPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 08:39'!
underPicture: aWoodCutPicture 

	underPicture :=aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #PictureQuartet
	instanceVariableNames: 'upperLeftPicture upperRightPicture lowerLeftPicture lowerRightPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureQuartet methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:02'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame ! !

!PictureQuartet methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:02'!
equivalentExpression

	^(upperLeftPicture beside: upperRightPicture) above: (lowerLeftPicture beside: lowerRightPicture)! !

!PictureQuartet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:00'!
functionName

	^'quartet'! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
lowerLeftPicture: aWoodCutPicture 

	lowerLeftPicture := aWoodCutPicture 
! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
lowerRightPicture: aWoodCutPicture 

	lowerRightPicture := aWoodCutPicture ! !

!PictureQuartet methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:25'!
parameterList
	
	^{ upperLeftPicture. upperRightPicture. lowerLeftPicture. lowerRightPicture }! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
upperLeftPicture: aWoodCutPicture 

	upperLeftPicture := aWoodCutPicture ! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
upperRightPicture: aWoodCutPicture 

	upperRightPicture := aWoodCutPicture ! !

FunctionalWoodCutPicture subclass: #SierpinskiPicture
	instanceVariableNames: 'subPicture blank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:06'!
blank: aWoodCutPicture

	blank := aWoodCutPicture! !

!SierpinskiPicture methodsFor: 'drawing' stamp: 'hjo 3/13/2008 18:50'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!SierpinskiPicture methodsFor: 'creation' stamp: 'hjo 3/13/2008 19:05'!
enhance

	^self copy subPicture: self; blank: blank		! !

!SierpinskiPicture methodsFor: 'creation' stamp: 'hjo 3/13/2008 19:07'!
equivalentExpression

	^(subPicture beside: blank) above: (subPicture beside: subPicture)! !

!SierpinskiPicture methodsFor: 'printing' stamp: 'hjo 3/13/2008 19:12'!
functionName

	^'sierpinski'! !

!SierpinskiPicture methodsFor: 'printing' stamp: 'hjo 3/13/2008 19:13'!
parameterList

	^ { self unitPicture. blank. WoodCutNumber value: self sierpinskiDepth }! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:10'!
sierpinskiDepth

	^subPicture sierpinskiDepth + 1! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:06'!
subPicture: aWoodCutPicture

	subPicture := aWoodCutPicture! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:04'!
unitPicture

	^subPicture unitPicture! !

FunctionalWoodCutPicture subclass: #UnaryFunctionalWoodCutPicture
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

UnaryFunctionalWoodCutPicture subclass: #FlippedPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!FlippedPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:21'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame flippedFrame! !

!FlippedPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:50'!
functionName

	^'flip'! !

!FlippedPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 14:02'!
simplified

	^picture class = self class
		ifTrue: [picture picture]
		ifFalse: [self]! !

UnaryFunctionalWoodCutPicture subclass: #PictureCycle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!PictureCycle methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:01'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame ! !

!PictureCycle methodsFor: 'creation' stamp: 'hjo 3/9/2008 10:24'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: picture;
		upperRightPicture: picture rotated rotated rotated ;
		lowerLeftPicture: picture rotated;
		lowerRightPicture: picture rotated rotated! !

!PictureCycle methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:59'!
functionName

	^'cycle'! !

UnaryFunctionalWoodCutPicture subclass: #RotatedBy45DegreesPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!RotatedBy45DegreesPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:43'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rotatedBy45Degrees! !

!RotatedBy45DegreesPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:54'!
functionName

	^'rot45'! !

UnaryFunctionalWoodCutPicture subclass: #RotatedPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!RotatedPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:16'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rotatedFrame! !

!RotatedPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:55'!
functionName

	^'rot'! !

!RotatedPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 14:01'!
simplified

	^(picture class = self class and: [
	picture picture class = self class and: [
	picture picture picture class = self class
	]])
		ifTrue: [picture picture picture picture]
		ifFalse: [self]! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
borderColor

	^picture borderColor
	! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
borderWidth

	^picture borderWidth! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
fillColor

	^picture fillColor! !

!UnaryFunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:51'!
parameterList

	^{ picture }! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
picture

	^picture! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
picture: aWoodCutPicture 

	picture :=aWoodCutPicture! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:29'!
shape

	^picture shape! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutTileT methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:21'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileT methodsFor: 'creating' stamp: 'hjo 3/6/2008 16:21'!
equivalentExpression

	| the2 the3 |
	the2 := picture pattern2.
	the3 := the2 triplyRotated.
	^picture over: (the2 over: the3)! !

!WoodCutTileT methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:52'!
functionName

	^'t'! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutTileU methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:29'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileU methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:31'!
equivalentExpression

	| the2 |
	the2 := picture pattern2.
	^(the2 over: the2 rotated) over:
		(the2 rotated rotated over: the2 rotated rotated rotated)
	! !

!WoodCutTileU methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:53'!
functionName

	^'u'! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutTileV methodsFor: 'drawing' stamp: 'hjo 3/9/2008 10:26'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileV methodsFor: 'creation' stamp: 'hjo 3/9/2008 10:37'!
equivalentExpression

	^picture tileTForm rotated cycled! !

!WoodCutTileV methodsFor: 'printing' stamp: 'hjo 3/9/2008 10:27'!
functionName

	^'v'! !

FunctionalWoodCutPicture subclass: #WoodCutCorner
	instanceVariableNames: 'exCorner exSide tileU'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutCorner methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:05'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	^self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame
! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:49'!
enhance

	^self copy
		exCorner: self;
		exSide: (exSide buildSide: (tileU picture tileTForm))! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:42'!
enhanceWithExSide: aWoodCutPicture

	^self copy
		exCorner: self;
		exSide: aWoodCutPicture! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:04'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: exCorner;
		upperRightPicture: exSide;
		lowerLeftPicture: exSide rotated;
		lowerRightPicture: tileU! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:26'!
exCorner: aWoodCutPicture

	exCorner := aWoodCutPicture! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:26'!
exSide: aWoodCutPicture

	exSide := aWoodCutPicture! !

!WoodCutCorner methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:10'!
functionName

	^'corner'! !

!WoodCutCorner methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:15'!
parameterList

	^{ tileU picture. WoodCutNumber value: self structureDepth }! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:15'!
structureDepth
	
	^exCorner structureDepth + 1! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:25'!
tileU: aWoodCutPicture

	tileU :=aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #WoodCutSide
	instanceVariableNames: 'exSide tileT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutSide methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:06'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutSide methodsFor: 'creation' stamp: 'hjo 3/5/2008 15:22'!
enhance

	^self copy
		exSide: self! !

!WoodCutSide methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:06'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: exSide;
		upperRightPicture: exSide;
		lowerLeftPicture: tileT rotated;
		lowerRightPicture: tileT! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:13'!
exSide: aWoodCutPicture

	exSide := aWoodCutPicture! !

!WoodCutSide methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:12'!
functionName

	^'side'! !

!WoodCutSide methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:14'!
parameterList

	^{ tileT picture. WoodCutNumber value: self structureDepth }! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:36'!
structureDepth

	^exSide structureDepth + 1! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:13'!
tileT: aWoodCutPicture

	tileT := aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #WoodCutSquareLimit
	instanceVariableNames: 'corner side tileU'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutSquareLimit classSide methodsFor: 'as yet unclassified' stamp: 'hjo 3/9/2008 11:19'!
picture: aWoodCutPicture

	| blank u |
	blank := WoodCutPicture blank.
	u := aWoodCutPicture tileUForm.
	^self new
		tileU: u;
		side: (WoodCutSide new tileT: aWoodCutPicture tileTForm; exSide: blank);
		corner: (WoodCutCorner new exCorner: blank; exSide: blank; tileU: u)! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:10'!
corner: aWoodCutPicture

	corner := aWoodCutPicture! !

!WoodCutSquareLimit methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:15'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutSquareLimit methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:45'!
enhance
	
	^self copy
		side: side enhance;
		corner: (corner enhanceWithExSide: side)! !

!WoodCutSquareLimit methodsFor: 'creation' stamp: 'hjo 3/6/2008 12:46'!
equivalentExpression

	| nonet tempSide tempCorner |
	nonet := PictureNonet new.
	nonet middle: tileU.
	
	"rotation 0"
	tempSide := side.
	tempCorner := corner.
	nonet 
		northWest: tempCorner;
		north: tempSide.

	"rotation 1"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		west: tempSide;
		southWest: tempCorner.
	
	"rotation 2"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		south: tempSide;
		southEast: tempCorner.
	
	"rotatiton 3"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		east: tempSide;
		northEast: tempCorner.
	
	^nonet
	! !

!WoodCutSquareLimit methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:14'!
functionName

	^'squarelimit'! !

!WoodCutSquareLimit methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:00'!
parameterList

	^ { tileU picture. WoodCutNumber value: self structureDepth }! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 15:47'!
side: aWoodCutPicture

	side := aWoodCutPicture! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:35'!
structureDepth

	^side structureDepth! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 16:15'!
tileU

	^tileU! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 15:47'!
tileU: aWoodCutPicture

	tileU := aWoodCutPicture! !

AbstractWoodCutPicture subclass: #WoodCutPicture
	instanceVariableNames: 'shape name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/6/2008 18:05'!
blank

	^self new shape: {}; name: 'blank'! !

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/7/2008 15:32'!
f

	^self new
		shape: self fShape;
		name: 'f'! !

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/6/2008 18:11'!
fShape
	
	| scale ux uy p nux nuy |
	scale := 1/7.
	ux := (1@0) *scale.
	uy := (0@1) *scale.
	nux := ux negated.
	nuy := uy negated.
	
	p := 0@0.

	^{
		ux + ux + uy.
		ux + ux +ux.
		uy.
		nux + nux.
		uy.
		ux.
		uy.
		nux.
		uy + uy.
		nux.
		nuy + nuy + nuy + nuy + nuy
	} collect: [:jump| p := p + jump ]
	! !

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/7/2008 15:49'!
fish

	^self new
		shape: self fishShape;
		name: 'fish'! !

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 09:26'!
fishShape

	"^{4@0. 3.5@5.5. 0@10. 4@13. 7@10. 11@13. 17@13. 14@10. 10.5@10. 10.5@3. 7@2.5} / (20@20)"
	"^ {0.17@0.18 . 0.145@0.455 . -0.03@0.68 . 0.17@0.83 . 0.32@0.68 . 0.52@0.83 . 0.82@0.83 . 0.67@0.68 . 0.495@0.68 . 0.495@0.33 . 0.32@0.305}"
	 "^{0.03073169484375002@0.0999422153125 . -0.002770696171874986@0.468468516484375 . -0.23728743328125@0.769990035625 . 0.03073169484375002@0.97100438171875 . 0.2317460409374999@0.769990035625 . 0.4997651690625@0.97100438171875 . 0.90179386125@0.97100438171875 . 0.70077951515625@0.769990035625 . 0.466262778046875@0.769990035625 . 0.466262778046875@0.30095656140625 . 0.2317460409374999@0.267454170390625}"
	^ {-0.01442422175650387@0.00569560700113284 . -0.0532074271559668@0.4323108663952245 . -0.324689864952207@0.781359714990391 . -0.01442422175650387@1.014058947387168 . 0.2182750106402733@0.781359714990391 . 0.528540653835977@1.014058947387168 . 0.993939118629531@1.014058947387168 . 0.761239886232754@0.781359714990391 . 0.4897574484365137@0.781359714990391 . 0.4897574484365137@0.23839483939791 . 0.2182750106402733@0.1996116339984472}! !

!WoodCutPicture classSide methodsFor: 'instance creation' stamp: 'hjo 3/13/2008 19:49'!
triangle

	^self new shape: { 0@0. 1@1. 0@1 }! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:23'!
borderColor

	^Color black! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:22'!
borderWidth

	^1! !

!WoodCutPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 20:46'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	shape isEmpty ifFalse: [ 
		aCanvas 
			drawPolygon: (aDaliotsFrame mappedPoints: shape) 
			color: self fillColor
			borderWidth: self borderWidth
			borderColor: self borderColor
	]! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:22'!
fillColor

	^Color red! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 18:04'!
name: aString

	name := aString! !

!WoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:04'!
printExpressionOn: aStream

	aStream nextPutAll: (name isNil ifTrue: ['<unnamed>'] ifFalse: [name])! !

!WoodCutPicture methodsFor: 'shape change' stamp: 'hjo 3/7/2008 23:24'!
scaleBy: aFloat 

	shape := shape * aFloat! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:41'!
shape

	^shape! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:15'!
shape: anArray

	shape := anArray! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:36'!
structureDepth

	^0! !

!WoodCutPicture methodsFor: 'shape change' stamp: 'hjo 3/7/2008 17:09'!
translate: aPoint

	shape := shape + aPoint! !

Object subclass: #CopyConcatenatingRoll
	instanceVariableNames: 'array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!CopyConcatenatingRoll methodsFor: 'accessing' stamp: 'hjo 9/10/2007 14:29'!
array
	^array! !

!CopyConcatenatingRoll methodsFor: 'accessing' stamp: 'hjo 9/10/2007 14:29'!
array: anArray 
	array _ anArray! !

!CopyConcatenatingRoll methodsFor: 'accessing' stamp: 'hjo 9/10/2007 14:29'!
shiftLeft: anInteger 
	array replaceFrom:1 to:array size with: (array copyFrom: anInteger+1 to: array size) , (array copyFrom: 1 to: anInteger)! !

!CopyConcatenatingRoll methodsFor: 'accessing' stamp: 'hjo 9/10/2007 14:29'!
shiftRight: anInteger 
	self shiftLeft: array size - anInteger! !

Object subclass: #DaliotsFrame
	instanceVariableNames: 'origin xVector yVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!DaliotsFrame classSide methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2008 22:16'!
ofWorld

	| wb |
	wb := World bounds.
	^self new
		origin: wb origin;
		xVector: wb topRight;
		yVector: wb bottomLeft! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 2/26/2008 23:24'!
downHalf

	^self copy
		origin: (origin + (yVector / 2 ));
		yVector: yVector / 2! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:06'!
downPart: yVectorOfUpPart

	^self copy
		origin: origin + yVectorOfUpPart;
		yVector: yVector - yVectorOfUpPart! !

!DaliotsFrame methodsFor: 'transformed frames' stamp: 'hjo 2/26/2008 22:53'!
flippedFrame

	^self species new
		origin: self origin + self xVector;
		xVector: self xVector negated;
		yVector: self yVector! !

!DaliotsFrame methodsFor: 'testing' stamp: 'hjo 3/7/2008 11:33'!
isRightAngle

	^(xVector crossProduct: yVector) > 0! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 2/29/2008 05:36'!
leftHalf

	^self copy
		xVector: self xVector / 2! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:49'!
leftPart: leftXVector

	^self copy
		xVector:leftXVector! !

!DaliotsFrame methodsFor: 'converting' stamp: 'hjo 2/29/2008 20:20'!
mappedPoint: aPoint 

	^((aPoint x * self xVector) + (aPoint y * self yVector) + self origin) truncated! !

!DaliotsFrame methodsFor: 'converting' stamp: 'hjo 2/29/2008 20:20'!
mappedPoints: anArray 

	^anArray collect: [:point| self mappedPoint: point ]! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:38'!
origin

	^origin! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:12'!
origin: aPoint 

	origin := aPoint! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 2/29/2008 05:38'!
rightHalf

	|halfX|
	halfX := xVector / 2.
	^self copy
		origin: self origin + halfX;
		xVector: halfX! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:59'!
rightPart: xVectorOfLeftPart

	^self copy
		origin: origin + xVectorOfLeftPart;
		xVector: xVector - xVectorOfLeftPart! !

!DaliotsFrame methodsFor: 'transformed frames' stamp: 'hjo 3/9/2008 12:20'!
rotatedBy45Degrees

	^self copy
		xVector: (xVector - yVector) / 2;
		yVector: (xVector + yVector) / 2
! !

!DaliotsFrame methodsFor: 'transformed frames' stamp: 'hjo 3/7/2008 11:34'!
rotatedFrame

	^self isRightAngle
		ifTrue: 
			[self copy
				origin: origin + yVector;
				xVector: yVector negated;
				yVector: xVector]
		ifFalse: 
			[self copy
				origin: origin + xVector;
				xVector: yVector;
				yVector: xVector negated]! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 2/26/2008 23:21'!
upHalf

	^self copy yVector: self yVector / 2! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:55'!
upPart: aPoint 

	^self copy yVector: aPoint! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:09'!
vector: aVector weightedBy: weight1 and: weight2 

	^(((0@0) * weight2) + (aVector * weight1)) / (weight1 + weight2)! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:39'!
xVector

	^xVector! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:16'!
xVector: aPoint 
	
	xVector := aPoint! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:08'!
xVectorWeightedBy: leftWeight and: rightWeight 

	^self vector: xVector weightedBy: leftWeight and: rightWeight! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:39'!
yVector

	^yVector! !

!DaliotsFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:17'!
yVector: aPoint 

	yVector := aPoint! !

!DaliotsFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:10'!
yVectorWeightedBy: topWeight and: bottomWeight

	^self vector: yVector weightedBy: topWeight and: bottomWeight! !

Object subclass: #DepthFirstAlgorithm
	instanceVariableNames: 'answers stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-common'!

!DepthFirstAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:13'!
answers

	answers isNil ifTrue: [answers := OrderedCollection new].
	^answers! !

!DepthFirstAlgorithm methodsFor: 'looping' stamp: 'hjo 2/2/2008 23:15'!
run

	[self stack isEmpty]
		whileFalse: [ self step ]! !

!DepthFirstAlgorithm methodsFor: 'looping' stamp: 'hjo 2/2/2008 21:48'!
runToFindOneAnswer

	[ self answers isEmpty ] whileTrue: [ self step ]! !

!DepthFirstAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:12'!
stack

	stack isNil ifTrue: [stack := Stack new].
	^stack! !

!DepthFirstAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:49'!
stackContents

	^String streamContents: [:stream| 
		self stack linkedList do: [:sl| sl element printOn: stream. stream cr ]
	]! !

!DepthFirstAlgorithm methodsFor: 'testing' stamp: 'hjo 2/2/2008 23:15'!
stackIsEmpty

	^self stack isEmpty! !

!DepthFirstAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:14'!
stackSize
	
	^self stack size! !

!DepthFirstAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:14'!
stackTop

	^self stack linkedList first! !

!DepthFirstAlgorithm methodsFor: 'looping' stamp: 'hjo 2/2/2008 23:15'!
step

	"override this for more control over processing agents"
	
	self stack pop spreadAmbiguous do: 
		[:agent| 
			agent isFullyConstructed
				ifTrue: [self answers add: agent]
				ifFalse: [self stack push: agent]
		]! !

DepthFirstAlgorithm subclass: #MagicSquareAlgorithm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!MagicSquareAlgorithm methodsFor: 'initialize-release' stamp: 'hjo 12/19/2007 11:39'!
reset

	self resetNByN: 3! !

!MagicSquareAlgorithm methodsFor: 'initialize-release' stamp: 'hjo 12/19/2007 11:39'!
resetNByN: anInteger

	stack := Stack new.
	stack push: (MagicSquare new initializeNByN: anInteger).
	answers := OrderedCollection new! !

!MagicSquareAlgorithm methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:47'!
stackContents

	^String streamContents: [:stream| 
		self stack linkedList do: [:sl| stream nextPutAll: sl element board privateContents printString. stream cr ]
	]! !

DepthFirstAlgorithm subclass: #SICPdriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SICP'!

!SICPdriver methodsFor: 'accessing' stamp: 'hjo 2/2/2008 23:53'!
answers

	answers isNil ifTrue: [answers := Set new].
	^answers! !

Object subclass: #FileSync
	instanceVariableNames: 'referencePath fileName destinationPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSync classSide methodsFor: 'instance creation' stamp: 'hjo 1/1/2008 03:35'!
from: aByteString to: aByteString2 for: aByteString3 

	^self new
		referencePath: aByteString;
		destinationPath:aByteString2;
		fileName:aByteString3;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:26'!
destinationFile
	^FileDirectory on: destinationPath , FileDirectory slash , fileName! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:36'!
destinationPath: aByteString 
	destinationPath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:48'!
destinationSide
	
	^FileSyncSide new
		path: destinationPath;
		itemName: fileName;
		yourself! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:37'!
fileName: aByteString 
	fileName :=aByteString! !

!FileSync methodsFor: 'creation' stamp: 'hjo 1/1/2008 02:20'!
init
	referencePath := 'refe'.
	destinationPath := 'des'.
	fileName := 'ff'! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 03:35'!
referencePath: aByteString 
	referencePath :=aByteString! !

!FileSync methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:11'!
referenceSide
	
	^FileSyncSide new
		path: referencePath;
		itemName: fileName;
		yourself! !

Object subclass: #FileSyncSide
	instanceVariableNames: 'path itemName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:42'!
fullPath

	^(path endsWithThese: FileDirectory slash)
		ifTrue: [self fullPathIfPathLastIsSlash]
		ifFalse: [self fullPathIfPathLastIsNotSlash]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:35'!
fullPathIfPathLastIsNotSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [path , itemName]
		ifFalse: [path , FileDirectory slash , itemName]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:37'!
fullPathIfPathLastIsSlash

	^(itemName beginsWithThese: FileDirectory slash)
		ifTrue: [ path , itemName copyWithoutFirst ]
		ifFalse: [ path , itemName ]! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:04'!
itemName: aString

	itemName :=aString! !

!FileSyncSide methodsFor: 'accessing' stamp: 'hjo 1/1/2008 23:03'!
path: aString

	path := aString! !

Object subclass: #FillInBySideSumMethod
	instanceVariableNames: 'magicSquare'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!FillInBySideSumMethod methodsFor: 'computing' stamp: 'hjo 12/18/2007 23:24'!
compute

	1 to: self primaryVectorCount do: [:primaryIndex|  |vector|
		vector := self getVector: primaryIndex.
		(vector occurrencesOf: nil) = 1
			ifTrue: [ |secondaryIndex|
				secondaryIndex := vector indexOf: nil.
				magicSquare set: (magicSquare sideSum - (vector select: [:e| e notNil]) sum) onBoardAt: (self matrixAccessPointFromTwoIndex: primaryIndex and: secondaryIndex).
				]
	]! !

!FillInBySideSumMethod methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:09'!
magicSquare: aMagicSquare

	magicSquare := aMagicSquare! !

FillInBySideSumMethod subclass: #FillInBySideSumMethodByColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!FillInBySideSumMethodByColumn methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:18'!
getVector: index

	^magicSquare board atColumn: index

	! !

!FillInBySideSumMethodByColumn methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:22'!
matrixAccessPointFromTwoIndex: primaryIndex and: secondaryIndex

	^secondaryIndex @ primaryIndex! !

!FillInBySideSumMethodByColumn methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:11'!
primaryVectorCount

	^magicSquare board columnCount! !

FillInBySideSumMethod subclass: #FillInBySideSumMethodByDiagonal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!FillInBySideSumMethodByDiagonal methodsFor: 'computing' stamp: 'hjo 12/19/2007 11:27'!
compute

	magicSquare boardDiagonals keysAndValuesDo: [:diagonalIndex :diagonal|
		(diagonal occurrencesOf: nil) = 1
			ifTrue: [ |rowIndex columnIndex|
				magicSquare assert: [#(1 2) includes: diagonalIndex].
				rowIndex := diagonal indexOf: nil.
				columnIndex := diagonalIndex = 1 ifTrue: [rowIndex] ifFalse: [magicSquare board columnCount- rowIndex+1].
				magicSquare set: (magicSquare sideSum - (diagonal select: [:e| e notNil]) sum) onBoardAt: rowIndex@columnIndex 
				]
	]! !

FillInBySideSumMethod subclass: #FillInBySideSumMethodByRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!FillInBySideSumMethodByRow methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:17'!
getVector: index

	^magicSquare board atRow: index

	! !

!FillInBySideSumMethodByRow methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:23'!
matrixAccessPointFromTwoIndex: primaryIndex and: secondaryIndex 

	^primaryIndex@secondaryIndex! !

!FillInBySideSumMethodByRow methodsFor: 'accessing' stamp: 'hjo 12/18/2007 23:13'!
primaryVectorCount

	^magicSquare board rowCount! !

Object subclass: #FramedPicture
	instanceVariableNames: 'picture frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!FramedPicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 18:15'!
drawOn: aCanvas

	picture drawOnCanvas: aCanvas usingFrame: frame.
	aCanvas drawString: picture expressionString at: frame origin + frame yVector! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:18'!
flipped

	^self copy picture: picture flipped! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:16'!
frame: aDaliotsFrame 

	frame := aDaliotsFrame! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:26'!
picture

	^picture! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:15'!
picture: aWoodCutPicture 

	picture := aWoodCutPicture! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:12'!
rotated

	^self copy
		picture: picture rotated! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:42'!
rotatedBy45Degrees

	^self copy picture: picture rotatedBy45Degrees! !

Object subclass: #IDontKnow
	instanceVariableNames: 's d stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-FileSync'!

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:27'!
encodeMacDirectory: aFileDirectory

	^String streamContents: [:ssss | 
		self encodeMacDirectory: aFileDirectory on: ssss ]! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:37'!
encodeMacDirectory: aFileDirectory on: pathStream

	aFileDirectory fullName = FileDirectory root fullName
		ifFalse: [ self encodeMacDirectory: aFileDirectory on: pathStream containingDirectory ].
		
	pathStream nextPutAll: FileDirectory slash.
	pathStream nextPutAll: (self encodeMacFileName: aFileDirectory fullName)! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:35'!
encodeMacFileName: aString

	^String streamContents:
		[:encoded|
			aString
				do: [:char| 
					self assert: [(':' includes: char) not].
					('1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-^{},+' includes: char) 
					ifTrue: [encoded nextPut: char ] 
					ifFalse: [
						char = $/ ifTrue: [encoded nextPut: $:] ifFalse: [encoded nextPut: $\; nextPut: char] ] ]	
		]

	! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:01'!
go

	s entries do: [:e|
		e isDirectory
			ifTrue: [ self goDirectory: e ]
			ifFalse: [ self goFile: e  ] 
		 ].
	^self stream contents! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 00:56'!
goDirectory: e 

	self streamMakeDir: e.
	(self subDir: e name)
		stream: self stream;
		go! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 17:18'!
goFile: e

	self stream 
		nextPutAll: 'cp -p '; 
		nextPutAll: (self encodeMacFileName: s fullName);
		nextPutAll: FileDirectory slash;
		nextPutAll: (self encodeMacFileName:e name);
		space;
		nextPutAll: (self encodeMacFileName: d fullName);
		nextPutAll: ';';
		cr! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:18'!
s: fd1 d: fd2

	s := fd1.
	d := fd2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 05:02'!
sp: s1 dp: s2

	s := FileDirectory on: s1.
	d := FileDirectory on: s2! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 13:38'!
stream

	stream isNil ifTrue: 
		[stream := WriteStream on: ByteString new].
	^stream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:17'!
stream: aWriteStream

	stream := aWriteStream! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/6/2008 11:28'!
streamMakeDir: e
	
	{ 'mkdir '. self encodeMacFileName: (d fullName, FileDirectory slash, e name). ';' }
		do: [:part| self stream nextPutAll: part].
		
	self stream cr
! !

!IDontKnow methodsFor: 'as yet unclassified' stamp: 'hjo 1/5/2008 06:19'!
subDir: aString

	^self class new
		s: (s directoryNamed: aString)
		d: (d directoryNamed: aString)! !

Object subclass: #JuggleRoll
	instanceVariableNames: 'array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!JuggleRoll classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:32'!
on: anArray by: anInteger

	^self new
		array: anArray;
		shiftBy: anInteger! !

!JuggleRoll classSide methodsFor: 'instance creation' stamp: 'hjo 9/22/2007 09:51'!
on: anArray by: anInteger from: rangeStart to: rangeStop
	
	^self new
		array: anArray;
		shiftBy: anInteger from: rangeStart to: rangeStop! !

!JuggleRoll classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:28'!
on: anArray by: anInteger indexOffset: indexOffset

	^self new
		array: anArray;
		shiftBy: anInteger indexOffset: indexOffset! !

!JuggleRoll classSide methodsFor: 'as yet unclassified' stamp: 'hjo 9/21/2007 20:29'!
on: anArray by: anInteger indexOffset: indexOffset from: rangeStart to: rangeStop
	^self new
		array: anArray;
		shiftBy: anInteger indexOffset: indexOffset from: rangeStart to: rangeStop! !

!JuggleRoll methodsFor: 'accessing' stamp: 'hjo 9/21/2007 17:59'!
array
	^array! !

!JuggleRoll methodsFor: 'accessing' stamp: 'hjo 9/21/2007 17:59'!
array: anArray 
	array := anArray! !

!JuggleRoll methodsFor: 'operation' stamp: 'hjo 9/21/2007 18:03'!
shiftBy: anInteger

	self shiftBy: anInteger from: 1 to: array size! !

!JuggleRoll methodsFor: 'operation' stamp: 'hjo 9/22/2007 10:28'!
shiftBy: anInteger from: rangeStart to: rangeStop 
	| rangeSize |
	anInteger = 0 ifTrue: [^ self].
	rangeSize := rangeStop - rangeStart + 1.
	anInteger >= rangeSize
		ifTrue: [^ self
				shiftBy: (anInteger rem: rangeSize)
				from: rangeStart
				to: rangeStop].
	(rangeSize rem: anInteger) = 0
		ifTrue: [1 to: anInteger
				do: [:indexOffset | self
						shiftBy: anInteger
						indexOffset: indexOffset
						from: rangeStart
						to: rangeStop]]
		ifFalse: [
			self
				forFailingCaseShiftBy: anInteger
				from: rangeStart
				to: rangeStop]! !

!JuggleRoll methodsFor: 'operation' stamp: 'hjo 9/21/2007 18:11'!
shiftBy: anInteger indexOffset: indexOffset

	^self shiftBy: anInteger indexOffset: indexOffset from: 1 to: array size! !

JuggleRoll subclass: #LeftJuggleRoll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!LeftJuggleRoll methodsFor: 'operation' stamp: 'hjo 9/22/2007 10:31'!
forFailingCaseShiftBy: anInteger from: rangeStart to: rangeStop 
	| rangeSize x |
	rangeSize := rangeStop - rangeStart.
	x := rangeSize // anInteger * anInteger + rangeStart - 1.
	LeftJuggleRoll on: array by: anInteger from: rangeStart to: x.
	RightJuggleRoll on: array by: rangeStop - x from: x - anInteger + 1 to: rangeStop! !

!LeftJuggleRoll methodsFor: 'operation' stamp: 'hjo 9/21/2007 20:13'!
shiftBy: anInteger indexOffset: indexOffset from: rangeStart to: rangeStop

	LeftJuggling new
		array: array;
		shift: anInteger;
		rangeStart: rangeStart;
		rangeStop: rangeStop;
		indexOffset: indexOffset;
		okGo! !

JuggleRoll subclass: #RightJuggleRoll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!RightJuggleRoll methodsFor: 'operation' stamp: 'hjo 9/22/2007 09:49'!
forFailingCaseShiftBy: anInteger from: rangeStart to: rangeStop 

	 |rangeSize x|
	rangeSize := rangeStop - rangeStart + 1.
	x := rangeStop - ((rangeSize//anInteger) * anInteger) + 1.
	RightJuggleRoll on: array by: anInteger from: x to: rangeStop.
	LeftJuggleRoll on: array by: x-rangeStart from: rangeStart to: x+anInteger-1! !

!RightJuggleRoll methodsFor: 'operation' stamp: 'hjo 9/21/2007 20:14'!
shiftBy: anInteger indexOffset: indexOffset from: rangeStart to: rangeStop

	RightJuggling new
		array: array;
		shift: anInteger;
		rangeStart: rangeStart;
		rangeStop: rangeStop;
		indexOffset: indexOffset;
		okGo! !

Object subclass: #Juggling
	instanceVariableNames: 'targetIndex indexOffset rangeStart rangeStop array sourceIndex shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!Juggling methodsFor: 'accessing' stamp: 'hjo 9/21/2007 20:00'!
array: anArray 
	array := anArray! !

!Juggling methodsFor: 'accessing' stamp: 'hjo 9/21/2007 20:02'!
indexOffset: anInteger 
	
	indexOffset := anInteger! !

!Juggling methodsFor: 'operation' stamp: 'hjo 9/21/2007 20:08'!
okGo

	| inTheAir |
	targetIndex := self initialTargetIndex..
	inTheAir := array at: targetIndex.
	[sourceIndex := self nextSourceIndex.
	self loopingCondition] whileTrue: 
		[array at: targetIndex put: (array at: sourceIndex).
		targetIndex := sourceIndex].
	array at: targetIndex put: inTheAir! !

!Juggling methodsFor: 'evaluation' stamp: 'hjo 9/22/2007 10:40'!
rangeSize

	^rangeStop - rangeStart! !

!Juggling methodsFor: 'accessing' stamp: 'hjo 9/21/2007 20:01'!
rangeStart: anInteger 
	rangeStart := anInteger! !

!Juggling methodsFor: 'accessing' stamp: 'hjo 9/21/2007 20:01'!
rangeStop: anInteger

	rangeStop := anInteger! !

!Juggling methodsFor: 'accessing' stamp: 'hjo 9/21/2007 20:00'!
shift: anInteger 

	shift := anInteger! !

Juggling subclass: #LeftJuggling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!LeftJuggling methodsFor: 'evaluating' stamp: 'hjo 9/22/2007 10:40'!
failGo

	"| rangeSize x |
	rangeSize := rangeStop - rangeStart.
	x := rangeSize // anInteger * anInteger + rangeStart - 1.
	LeftJuggleRoll on: array by: anInteger from: rangeStart to: x.
	RightJuggleRoll on: array by: rangeStop - x from: x - anInteger + 1 to: rangeStop"
	| rangeSize failCutIndex |
	rangeSize := self rangeSize.
	failCutIndex := rangeSize // shift * shift + rangeStart - 1.
	LeftJuggleRoll on: array by: shift from: rangeStart to: failCutIndex.
	RightJuggleRoll on: array by: rangeStop - failCutIndex from: failCutIndex - shift + 1 to: rangeStop! !

!LeftJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:10'!
initialTargetIndex
	^indexOffset + rangeStart - 1! !

!LeftJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:07'!
loopingCondition
	^sourceIndex <= rangeStop! !

!LeftJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:07'!
nextSourceIndex
	^targetIndex + shift! !

Juggling subclass: #RightJuggling
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Juggle'!

!RightJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:09'!
initialTargetIndex
	^rangeStop - indexOffset + 1! !

!RightJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:10'!
loopingCondition
	^sourceIndex >= rangeStart! !

!RightJuggling methodsFor: 'evaluating' stamp: 'hjo 9/21/2007 20:09'!
nextSourceIndex
	^targetIndex - shift! !

Object subclass: #MagicSquare
	instanceVariableNames: 'board sideSum unchosenNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-MagicSquare'!

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/11/2007 15:50'!
board
	^board! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/4/2007 21:21'!
board: aMatrix 

	board := aMatrix! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/4/2007 21:40'!
boardDiagonals

	"A foreign method for Matrix"
	|nDiagonal|
	nDiagonal := Array new: board rowCount.
	1 to: board rowCount do: [:k|
		nDiagonal at: k put: (board at: k at: (board columnCount - k + 1))
		].
	^Array 
		with: board diagonal
		with: nDiagonal! !

!MagicSquare methodsFor: 'setting number' stamp: 'hjo 12/19/2007 11:35'!
fillInBySideSum

	{FillInBySideSumMethodByRow. 
	FillInBySideSumMethodByColumn. 
	FillInBySideSumMethodByDiagonal}
		do: [:methodClass| methodClass new magicSquare: self; compute ]! !

!MagicSquare methodsFor: 'setting number' stamp: 'hjo 12/18/2007 22:51'!
fillInBySideSumWithNoError: outs

	|errorObjects|
	errorObjects := OrderedCollection new.
	outs do: [:e| [e fillInBySideSum ] on: AssertionFailure do: [:error| errorObjects add: e] ].
	^outs reject: [:ea| errorObjects includes: ea]! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 12/4/2007 21:45'!
hasNoDuplicateNumbers

	|numbers|
	numbers := board asOrderedCollection select: [:each| each notNil].
	^numbers size = numbers asSet size! !

!MagicSquare methodsFor: 'initialize-release' stamp: 'hjo 12/19/2007 11:36'!
initialize3x3

	^self initializeNByN:3! !

!MagicSquare methodsFor: 'initialize-release' stamp: 'hjo 12/19/2007 11:36'!
initializeNByN: anInteger

	board := Matrix rows: anInteger columns: anInteger.
	sideSum := nil.
	unchosenNumbers := OrderedCollection withAll: (1 to: anInteger squared)! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 12/3/2007 22:56'!
isAmbiguous

	^board includes: nil! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 12/3/2007 22:41'!
isCorrectSoFar

	^self isNumberInBetween and: [ self hasNoDuplicateNumbers and: [self sideSumCorrect]]
	! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 2/2/2008 22:26'!
isFullyConstructed

	^(board includes: nil) not! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 12/11/2007 17:33'!
isNumberInBetween

	| boardContents numberRangeBigEnd |
	boardContents := board privateContents.
	numberRangeBigEnd := boardContents size.
	^boardContents allSatisfy: [:num| num isNil or: [num between: 1 and: numberRangeBigEnd ]]! !

!MagicSquare methodsFor: 'setting number' stamp: 'hjo 12/4/2007 21:24'!
set: anInteger onBoardAt: aPoint

	self assert: [ unchosenNumbers includes: anInteger ].
	self assert: [ (board at: aPoint x at: aPoint y) isNil ].
	unchosenNumbers remove: anInteger.
	board at: aPoint x at: aPoint y put: anInteger! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/18/2007 22:50'!
sideSum

	sideSum isNil ifTrue: 
		[|n| 
		n := board contents size.
		sideSum := (n*(n+1)/2/n sqrt) truncated ].
	^sideSum! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/4/2007 21:22'!
sideSum: anInteger 

	sideSum := anInteger! !

!MagicSquare methodsFor: 'testing' stamp: 'hjo 12/12/2007 18:54'!
sideSumCorrect

	^self vectors allSatisfy: [:vec| (vec includes: nil) or: [vec sum = self sideSum]]! !

!MagicSquare methodsFor: 'breeding' stamp: 'hjo 12/18/2007 22:50'!
spreadAmbiguous

	| outs |
	outs := self spreadOneWildCard.
	outs := self fillInBySideSumWithNoError: outs.
	outs := outs select: [:ea| ea isCorrectSoFar ].
	^outs! !

!MagicSquare methodsFor: 'breeding' stamp: 'hjo 12/18/2007 22:45'!
spreadOneWildCard

	| nilIndex |
	nilIndex := board indexOf: nil.
	^unchosenNumbers collect: [:un| self symanticCopy set: un onBoardAt: nilIndex]
! !

!MagicSquare methodsFor: 'copying' stamp: 'hjo 12/4/2007 21:21'!
symanticCopy

	^self species new
		board: board deepCopy;
		sideSum: self sideSum deepCopy;
		unchosenNumbers: unchosenNumbers deepCopy
		! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/4/2007 21:22'!
unchosenNumbers: anOrderedCollection 

	unchosenNumbers := anOrderedCollection! !

!MagicSquare methodsFor: 'accessing' stamp: 'hjo 12/4/2007 21:49'!
vectors

	"A foreign method for Matrix"
	|stream|
	stream := WriteStream on: (Array new: board rowCount + board columnCount + 2).
	1 to: board rowCount do: [:k| stream nextPut: (board atRow: k)].
	1 to: board columnCount do: [:k| stream nextPut: (board atColumn: k)].
	stream nextPutAll: self boardDiagonals.
	^stream contents
	! !

Object subclass: #MaxClub
	instanceVariableNames: 'members evaluator maximum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-Maxclub'!

!MaxClub commentStamp: 'hjo 3/17/2008 13:27' prior: 0!
If you want a MinClub, then just negate the value of evaluator block.!

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:28'!
evaluator: monoBlock

	evaluator := monoBlock! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:32'!
forNumbers

	^self new evaluator: [:number | number ]! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:28'!
maximum

	^maximum! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:28'!
maximum: aNumber

	members := nil.	
	maximum := aNumber! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:29'!
members

	members isNil ifTrue: [members := OrderedCollection new].
	^members! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:30'!
put: anObject

	"Answers boolean, if anObject is acceptted by me"
	| value |
	value := evaluator value: anObject.
	(self maximum isNil or: [value > self maximum]) 
		ifTrue: [ self setMaximum: value member: anObject. ^true ].
	value < self maximum
		ifTrue: [ ^false ].
	value = self maximum
		ifTrue: [ self members add: anObject. ^true ].
	self error: 'No one can reach here.'! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:30'!
putAll: aCollection

	aCollection do: [:object| self put: object ]! !

!MaxClub methodsFor: 'as yet unclassified' stamp: 'hjo 3/17/2008 13:31'!
setMaximum: aNumber member: anObject

	self maximum: aNumber.
	self members add: anObject! !

Object subclass: #SICP
	instanceVariableNames: 'coinTypes coins remain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-SICP'!

!SICP classSide methodsFor: 'instance creation' stamp: 'hjo 2/15/2008 18:48'!
ex100

	^self new
		remain: 100;
		coinTypes: {100. 50. 10};
		yourself! !

!SICP classSide methodsFor: 'instance creation' stamp: 'hjo 2/4/2008 12:53'!
ex200

	^self new
		remain: 200;
		yourself! !

!SICP methodsFor: 'testing' stamp: 'hjo 2/2/2008 23:00'!
= aSICP

	^self c100 = aSICP c100 and: [
	self c50 = aSICP c50 and: [
	self c10 = aSICP c10 and: [
	self remain = aSICP remain
	]]]! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:55'!
c10

	| ai |
	ai := self coinTypes indexOf: 10.
	^self coins at: ai! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:45'!
c100

	| ai |
	ai := self coinTypes indexOf: 100.
	^self coins at: ai! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:40'!
c100: anInteger

	| ai |
	ai := self coinTypes indexOf: 100.
	self coins at: ai put: anInteger! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:56'!
c10: anInteger

	| ai |
	ai := self coinTypes indexOf: 10.
	self coins at: ai put: anInteger! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:55'!
c50

	| ai |
	ai := self coinTypes indexOf: 50.
	^self coins at: ai! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 19:00'!
c50: anInteger

	| ai |
	ai := self coinTypes indexOf: 50.
	self coins at: ai put: anInteger! !

!SICP methodsFor: 'copying' stamp: 'hjo 3/16/2008 22:14'!
coinCopy

	^self species new
		coins: self coins copy;
		coinTypes: self coinTypes;
		yourself! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 15:47'!
coinSum

	^(self c100 * 100)
	+ (self c50 * 50)
	+ (self c10 * 10)! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 19:25'!
coinType: typeInteger count: anInteger

	| ai |
	ai := self coinTypes indexOf: typeInteger.
	self coins at: ai put: anInteger! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:47'!
coinTypes

	coinTypes isNil ifTrue: [ coinTypes := {} ].
	^coinTypes! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:49'!
coinTypes: anArray

	self assert: [ coinTypes isNil ].
	coinTypes := anArray! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/15/2008 18:52'!
coins

	coins isNil ifTrue: 
	[ 
		coins := (Array new: self coinTypes size) 
			collect: [:each | 0 ]
	].
	^coins! !

!SICP methodsFor: 'accessing' stamp: 'hjo 3/16/2008 22:15'!
coins: anArray 
	
	coins := anArray! !

!SICP methodsFor: 'testing' stamp: 'hjo 2/2/2008 23:04'!
hash

	^self remain hash * 1009 +
	self c100 hash * 1013 +
	self c50 hash * 1019 +
	self c10 hash! !

!SICP methodsFor: 'testing' stamp: 'hjo 2/2/2008 23:44'!
isFullyConstructed

	^self isSolved! !

!SICP methodsFor: 'testing' stamp: 'hjo 2/2/2008 22:50'!
isNormal

	^self c100 >= 0 and: [
	self c50 >= 0 and: [
	self c10 >= 0 and: [
	self remain >= 0 ]]]! !

!SICP methodsFor: 'testing' stamp: 'hjo 2/2/2008 15:49'!
isSolved

	^self remain isZero! !

!SICP methodsFor: 'printing' stamp: 'hjo 2/2/2008 21:33'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self c100 printOn: aStream.
	aStream space.
	self c50 printOn: aStream.
	aStream space.
	self c10 printOn: aStream.
	aStream space.
	self remain printOn: aStream.
	aStream nextPut: $).! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/2/2008 15:50'!
remain

	self assert: [ remain notNil ].  
	^remain! !

!SICP methodsFor: 'accessing' stamp: 'hjo 2/2/2008 15:46'!
remain: anInteger

	remain := anInteger! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 23:43'!
spreadAmbiguous

	^self variations! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 22:43'!
sum

	^self coinSum + self remain! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 16:46'!
variationC10

	^self coinCopy
		remain: self remain - 10;
		c10: self c10 + 1;
		yourself! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 21:30'!
variationC100

	^self coinCopy
		remain: self remain - 100;
		c100: self c100 + 1;
		yourself

	! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 16:15'!
variationC50

	^self coinCopy
		remain: self remain - 50;
		c50: self c50 + 1;
		yourself! !

!SICP methodsFor: 'generating' stamp: 'hjo 2/2/2008 16:57'!
variations

	^{self variationC100.
	self variationC50.
	self variationC10}
		select: [:each | each isNormal ]! !

Object subclass: #VendingMachine
	instanceVariableNames: 'coins insertedMoney changeBox bottomCompartment productRails'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-VendingMachine'!

!VendingMachine classSide methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:49'!
new

	^super new initialize! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:44'!
bottomCompartment

	^bottomCompartment! !

!VendingMachine methodsFor: 'accessing' stamp: 'hjo 4/24/2007 04:32'!
bottomCompartmentAsArray
	^self bottomCompartment asArray! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:44'!
changeBox
	^changeBox! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:06'!
changeBox: aBag

	changeBox := aBag.
	self triggerEvent: #changeBoxChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/24/2007 04:23'!
changeBoxAsArray
	^self changeBox asArray! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:45'!
coins

	^coins! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:06'!
coins: aBag

	coins := aBag.
	self triggerEvent: #coinsChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:06'!
emptyBottomCompartment

	bottomCompartment := Bag new.
	self triggerEvent: #bottomCompartmentChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:45'!
emptyChangeBox

	self changeBox: Bag new! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:45'!
emptyCoins

	self coins: Bag new! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/25/2007 06:19'!
initialize

	insertedMoney := 0.
	coins := Bag new.
	changeBox := Bag new.
	bottomCompartment := Bag new.
	productRails := OrderedCollection 
		with: (VendingMachineProductRail new productName: 'Mocca Cola'; price: 800; stock: 20; vendingMachine: self)
		with: (VendingMachineProductRail new productName: 'Zealot Tea'; price: 500; stock: 10; vendingMachine: self)
		with: (VendingMachineProductRail new productName: 'KIN Cidar'; price: 650; stock: 30; vendingMachine: self)! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:47'!
insertCoin10

	self insertCoin: 10! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:47'!
insertCoin100

	self insertCoin: 100! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:47'!
insertCoin50
	
	self insertCoin: 50! !

!VendingMachine methodsFor: 'user interface' stamp: 'hjo 4/13/2007 06:15'!
insertCoin500
	
	self insertCoin: 500! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:06'!
insertCoin: anInteger 

	self insertedMoney: self insertedMoney + anInteger.
	coins add: anInteger.
	self triggerEvent: #coinsChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:47'!
insertedMoney
	^insertedMoney! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:06'!
insertedMoney: anInteger
	
	insertedMoney := anInteger.
	self triggerEvent: #insertedMoneyChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:47'!
productRails

	^productRails! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:31'!
returnChange

	|backup|
	backup := self rollbackCopy.
	[
		[insertedMoney > 0] whileTrue:
			[	|sortedCoinKinds biggestCoin|
				sortedCoinKinds := coins asSet asSortedCollection.
				[	biggestCoin := sortedCoinKinds removeLast. 
					biggestCoin > insertedMoney	]	whileTrue.
				self insertedMoney: insertedMoney - biggestCoin.
				changeBox add: (coins remove: biggestCoin)
			]]
	on: Error 
	do: [:excp| 
         excp messageText = 'this collection is empty'
           ifTrue: [
		self rollbackTo: backup.
		self error: 'Coin short!!!!'] ifFalse:[excp signal] ].
	self assert: [insertedMoney = 0].
	self triggerEvent: #changeBoxChanged.
	self triggerEvent: #coinsChanged! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:28'!
rollbackCopy

	^self class new
		insertedMoney: self insertedMoney;
		coins: self coins copy;
		changeBox: self changeBox copy! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:48'!
rollbackTo: aVendingMachine

	self insertedMoney: aVendingMachine insertedMoney.
	self coins: aVendingMachine coins.
	self changeBox: aVendingMachine changeBox! !

!VendingMachine methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:48'!
zeroInsertedMoney

	self insertedMoney: 0! !

Object subclass: #VendingMachineProductRail
	instanceVariableNames: 'productName price stock vendingMachine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-VendingMachine'!

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:07'!
addOneProduct

	stock := stock + 1.
	self triggerEvent: #stockChanged! !

!VendingMachineProductRail methodsFor: 'accessing' stamp: 'hjo 4/25/2007 07:06'!
buttonLabel

	^self hasProduct
		ifTrue: ['buy'] ifFalse: ['sold out']! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2008 14:23'!
buyProduct

	vendingMachine insertedMoney < price ifTrue: [self error: 'Need more money to buy it.'].
	self removeOneProduct.
	vendingMachine bottomCompartment add: productName.
	vendingMachine insertedMoney: vendingMachine insertedMoney - price.
	vendingMachine triggerEvent: #bottomCompartmentChanged! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:50'!
canBeSold

	^self insertedMoneyIsEnough and: [self hasProduct]! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:50'!
hasProduct

	^stock>0! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:50'!
insertedMoneyIsEnough

	^vendingMachine notNil and: [vendingMachine insertedMoney >= price]! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:50'!
price

	^price! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:07'!
price: anInteger 
	price := anInteger.
	self triggerEvent: #priceChanged! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:50'!
productName
	^productName! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:07'!
productName: aString 
	productName := aString.
	self triggerEvent: #productNameChanged! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 06:07'!
removeOneProduct

	stock := stock - 1.
	self triggerEvent: #stockChanged! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:51'!
stock: anInteger 
	stock := anInteger! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:51'!
vendingMachine

	^vendingMachine! !

!VendingMachineProductRail methodsFor: 'as yet unclassified' stamp: 'hjo 4/13/2007 05:51'!
vendingMachine: aVendingMachine

	vendingMachine := aVendingMachine! !

Object subclass: #WoodCutNumber
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!WoodCutNumber classSide methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 11:40'!
value: aSmallInteger 

	^self new value: aSmallInteger! !

!WoodCutNumber methodsFor: 'printing' stamp: 'hjo 3/9/2008 11:41'!
printExpressionOn: aWriteStream 
	
	aWriteStream print: value! !

!WoodCutNumber methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:40'!
value: aSmallInteger 

	value := aSmallInteger! !

Object subclass: #WoodCutShow
	instanceVariableNames: 'framedPictures unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

WoodCutShow subclass: #BasicTestShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!BasicTestShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:55'!
frameSize

	"size of default square frame size."
	^60! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 10:44'!
install

	framedPictures := OrderedCollection new.
	
	self installRot.
	self installFlip.
	self installFlipRot.
	self installRotFlip.
	self installAbove.
	self installBeside.
	self installBesideAbove.
	self installRot45.
	self installRot45Flip.
	self installOver.
	self installBasicTwice.
	self installTiles.
	self installQuartet.
	self installCycle.
	self installSide.
	self installCorner.
	self installNonet.
	self installSquareLimit! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:35'!
installAbove

	self add: unit coordination: 0@4.
	self add: (unit above: unit) coordination: 1@4! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:35'!
installBasicTwice

	self add: 
		(PictureOverPicture new
			underPicture: unit;
			overPicture: unit rotated rotated)
		coordination: 6@0! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installBeside

	self add: unit coordination: 3@4.
	self add: (unit beside: unit) coordination: 4@4! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installBesideAbove

	framedPictures add:
		(FramedPicture new
			picture: ((unit beside: unit) above: unit);
			frame: (self coordinatedFrame: 6@4))
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installCorner

	| blank corner |
	blank := WoodCutPicture blank.
	corner := WoodCutCorner new
		exCorner: blank;
		exSide: blank;
		tileU: unit tileUForm.
	
	self add: corner coordination: 8@1.
	corner := corner enhance.
	self add: corner coordination: 10@1.
	corner := corner enhance.
	self add: corner coordination: 12@1.
	corner := corner enhance.
	self add: corner coordination: 14@1.
	! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 09:54'!
installCycle

	self add: (PictureCycle new picture: unit) coordination: 2@6
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installFlip

	self add: unit coordination: 0@1.
	self add: unit flipped coordination: 1@1.
	self add: unit flipped flipped coordination: 2@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installFlipRot

	self add: unit coordination: 0@2.
	self add: unit flipped coordination: 1@2.
	self add: unit flipped rotated coordination: 2@2.
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:18'!
installNonet

	self add: (PictureNonet new
		northWest: unit; north: unit; northEast: unit;
		west: unit; middle: unit; east: unit;
		southWest: unit; south: unit; southEast: unit) coordination: 4@6! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installOver

	self add: (unit rotatedBy45Degrees over: unit) coordination: 4@3! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installQuartet

	self add: (PictureQuartet new
		upperLeftPicture: unit;
		upperRightPicture: unit;
		lowerLeftPicture: unit;
		lowerRightPicture: unit) coordination: 0@6.
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot

	self add: unit coordination: 0@0.
	self add: unit rotated coordination: 1@0.
	self add: unit rotated rotated coordination: 2@0.
	self add: unit rotated rotated rotated coordination: 3@0.
	self add: unit rotated rotated rotated rotated coordination: 4@0! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot45

	self add: unit rotatedBy45Degrees coordination: 4@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot45Flip

	self add: unit flipped rotatedBy45Degrees coordination: 5@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRotFlip

	self add: unit coordination: 0@3.
	self add: unit rotated coordination: 1@3.
	self add: unit rotated flipped coordination: 2@3
	! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installSide

	| side |
	side := WoodCutSide new.
	side exSide: WoodCutPicture blank.
	side tileT: unit tileTForm.
	self add: side coordination: 8@0.
	side := side enhance.
	self add: side coordination: 10@0.
	side := side enhance.
	self add: side coordination: 12@0.
	side := side enhance.
	self add: side coordination: 14@0.
	
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:19'!
installSquareLimit

	| sl |
	sl := WoodCutSquareLimit picture: unit.
	self add: sl coordination: 8@2.
	sl := sl enhance.
	self add: sl coordination: 10@2.
	sl := sl enhance.
	self add: sl coordination: 12@2.
	sl := sl enhance.
	self add: sl coordination: 14@2.! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installTileTAndU

	| the2 the3 t |
	the2 := unit pattern2.
	the3 := the2 triplyRotated.
	t := unit tileTForm.
	
	self add: the2 coordination: 0@5.
	self add: the3 coordination: 1@5.
	self add: t coordination: 2@5.
	self add: unit tileUForm coordination: 4@5! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 10:46'!
installTiles

	| the2 the3 t |
	the2 := unit pattern2.
	the3 := the2 triplyRotated.
	t := unit tileTForm.
	
	self add: the2 coordination: 0@5.
	self add: the3 coordination: 1@5.
	self add: t coordination: 2@5.
	self add: unit tileUForm coordination: 4@5.
	self add: unit tileVForm coordination: 6@5! !

WoodCutShow subclass: #FishTileFittingShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!FishTileFittingShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:56'!
frameSize

	"size of default square frame size."
	^120! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:32'!
install

	framedPictures := OrderedCollection new.
	
	self installSimple.
	self installSquareLimit
! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:31'!
installSimple

	self add: unit coordination: 1@1.
	self add: (unit over: unit rotated rotated) coordination: 3@1.
	self add: unit tileTForm coordination: 5@1.
	self add: unit tileUForm coordination: 7@1.
	self add: unit tileUForm quartetOfOne coordination: 1@2.
	self add: unit tileVForm coordination: 3@2.
	self add: unit tileVForm quartetOfOne coordination: 5@2
! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:41'!
installSquareLimit

	| sl |
	sl := WoodCutSquareLimit picture: unit.
	self add: sl coordination: 1@3.

	sl := sl enhance.
	self add: sl coordination: 3@3.

	sl := sl enhance.
	self add: sl coordination: 5@3.

	sl := sl enhance.
	self add: sl coordination: 7@3
! !

WoodCutShow subclass: #SierpinskiShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Daliot-WoodCut'!

!SierpinskiShow methodsFor: 'drawing-layout' stamp: 'hjo 3/13/2008 19:24'!
frameSize

	^120! !

!SierpinskiShow methodsFor: 'initialize-release' stamp: 'hjo 3/13/2008 19:25'!
install

	| sier |
	framedPictures _ OrderedCollection new.
	
	sier _ SierpinskiPicture new subPicture: unit; blank: WoodCutPicture blank.
	self add: sier coordination: 1@1.
	sier _ sier enhance.
	self add: sier coordination: 3@1.
	sier _ sier enhance.
	self add: sier coordination: 5@1.
	sier _ sier enhance.
	self add: sier coordination: 7@1.
! !

!WoodCutShow classSide methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 12:01'!
f

	^self new unit: WoodCutPicture f! !

!WoodCutShow classSide methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 12:01'!
fish

	^self new unit: WoodCutPicture fish! !

!WoodCutShow classSide methodsFor: 'instance creation' stamp: 'hjo 3/13/2008 19:48'!
triangle

	^self new unit: WoodCutPicture triangle! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:31'!
add: aWoodCutPicture coordination: coordination

	framedPictures add: (FramedPicture new picture: aWoodCutPicture; frame: (self coordinatedFrame: coordination))! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/4/2008 10:55'!
coordinatedFrame: coordination

	^self defaultFrame
		origin: (self frameOriginForCoordination: coordination)! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/4/2008 11:36'!
defaultFrame

	^DaliotsFrame new
		origin: 0@0;
		xVector: self frameSize@0;
		yVector: 0@self frameSize! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 2/29/2008 06:35'!
frameOriginForCoordination: coordination

	^ (coordination x  @ (coordination y * (1+self yMargin)) * self frameSize) truncated! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/4/2008 07:54'!
frameSize

	"size of default square frame size."
	^60! !

!WoodCutShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:52'!
install

	" build framedPicture list "
	self subclassResponsibility! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 3/7/2008 15:19'!
paint

	self paintOn: World canvas! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 3/7/2008 16:32'!
paintOn: aCanvas

	framedPictures do: [:pict| pict drawOn: aCanvas ].
! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 2/23/2008 16:48'!
restoreDisplay

	Display restore! !

!WoodCutShow methodsFor: 'accessing' stamp: 'hjo 3/7/2008 17:02'!
unit

	^unit! !

!WoodCutShow methodsFor: 'accessing' stamp: 'hjo 3/7/2008 14:47'!
unit: aWoodCutPicture

	unit := aWoodCutPicture! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 2/29/2008 06:35'!
yMargin

	^0.5! !
